#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fileconst.h"

#include "ChanInfo.h"


CChanInfo::CChanInfo( char *keyfile ) 
  : SpeakId(0), MicType(0), NrSpeaker(0)
{

  char line[MaxLineLength] ;
  int speakercount = 0, i, flag=0  ;
  FILE *tmpfp ;
  char *token;

  // open keyfile
  FILE *fp = fopen( keyfile, "r" ) ;
  if( fp == 0 ) {
    fprintf( stderr, "Can't open KeyFile '%s', exit program!\n", keyfile ) ;
    exit(-1) ;
  } ;

  // get Nr of participants from filed 'PARTICIPANTS'
  while( fgets( line, MaxLineLength, fp ) != 0 ) {
    if( strncmp( line, "PARTICIPANTS", strlen("PARTICIPANTS") ) == 0 ) {
      // read next lines until empty line is reached, first entry is SpeakerId (use "," as separator!)
      tmpfp = fp ; // memorize this line
      while( fgets( line, MaxLineLength, fp ) != 0 && strncmp( line, " ", 1 ) != 0 )
	speakercount++ ;
    }
  } ;
  if( speakercount > 0 )
    NrSpeaker = speakercount ;
  else { 
    fprintf( stderr, "No Speakers found in KeyFile '%s'\n", keyfile ) ;
    exit(-1) ;
  } ;
      
  // allocate arrays now
  SpeakId = new char*[NrSpeaker] ;
  MicType = new EMicType[NrSpeaker] ;
  for( i=0 ; i<NrSpeaker; i++ ) 
    SpeakId[i] = new char[MaxLineLength] ;
  
  
  
  // return to 'PARTICIPANTS' line and read in names!
  fp = tmpfp ;
  for( i=0 ; i<NrSpeaker; i++ ) {
    fgets( line, MaxLineLength, fp ) ;
    token = strtok( line, "\t" ) ;
    token = strtok( NULL, "," ) ;
    strcpy( SpeakId[i], token ) ;
    
#ifdef TESTLEVEL
    fprintf( stderr, "SpeakerId[%d]: %s\n", i, SpeakId[i] ) ;
#endif
  } ;
  
  // continue to "DESCRIPTION"
  while( fgets( line, MaxLineLength, fp ) != 0 ) {
    
    if( strstr( line, "DESCRIPTION" ) != 0 ) {
      flag = 1 ;
      // start search for names, to get MicTypes
      tmpfp = fp ; // memorize position
      
      for( i=0 ; i<NrSpeaker ; i++ ) {
	// return to memorized position
	fp = tmpfp ;
	while( fgets( line, MaxLineLength, fp ) ) {
	  if( strstr( line, SpeakId[i] ) != 0 ) {
	    if( strstr( line, "radio" ) != 0 && strstr( line, "lavalier" ) != 0 ) {
	      MicType[i] = RadioLapel ;
	    } else if( strstr( line, "radio" ) != 0 && strstr( line, "headset" ) != 0 ) {
	      MicType[i] = RadioHeadset ;
	    } else if( strstr( line, "PDA" ) != 0 ) {
	      MicType[i] = PDA ;
	    } else if( strstr( line, "PZM" ) != 0 ) {
	      MicType[i] = PZM ;
	    } else if( strstr( line, "headset" ) != 0 ) {
	      MicType[i] = Headset ;
	    } else if( strstr( line, "lavalier" ) != 0 ) {
	      MicType[i] = Lapel ;
	    } else
	      MicType[i] = Unknown ;
	    // proceed to next speaker
	    break ;
	  } ;
	} ;
#ifdef TESTLEVEL
	fprintf( stderr, "MicType[%d]: %d\n", i, MicType[i] ) ;
#endif
      } ;
    } ;
    if( flag == 1 )
      break ;
  } ;
}


CChanInfo::~CChanInfo() {
  int i ;
  for( i=0 ;i<NrSpeaker ; i++ ) {
    if( SpeakId[i] != 0 )
      delete[] SpeakId ;
  } ;
  
  if( SpeakId != 0 )
    delete[] SpeakId ;
  
  if( MicType != 0 )
    delete[] MicType ;
} ;
  
