#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main( int argc, char *argv[] ) {

  // check params:
  if( argc !=4 ) {
    fprintf( stderr, "USAGE: %s <nrframes> <label> <outfile>\n", argv[0] ) ;
    exit(-1) ;
  } ;

  FILE *outfp = fopen( argv[3], "w" ) ;
  if( outfp == 0 ) {
    fprintf( stderr, "Can't open outfile: %s\n", argv[3] ) ;
    exit(-1) ;
  } ;

  int nrframes = strtol( argv[1], NULL, 10 ) ;
  int sent = 0 ;
  int label = strtol( argv[2], NULL, 10 ) ;



  fprintf( outfp, "-pfile_header version 0 size 32768\n" ) ;
  fprintf( outfp, "-num_sentences 1\n" ) ;
  fprintf( outfp, "-num_frames %d\n", nrframes ) ;
  fprintf( outfp, "-first_feature_column 2\n" ) ;
  fprintf( outfp, "-num_features %d\n", 0 ) ;
  fprintf( outfp, "-first_label_column %d\n", 2 ) ;
  fprintf( outfp, "-num_labels %d\n", 1 ) ;
  fprintf( outfp, "-format %s\n", "2dd" ) ;
  fprintf( outfp, "-data size %d offset %d ndim %d nrow %d ncol %d\n",  nrframes*(1+2), 0, 2, nrframes, 1+2  ) ;
  fseek( outfp, 32768, 0 ) ;


  for( int i=0 ; i< nrframes ; i++ ) {
    fwrite( &sent,  sizeof(int), 1, outfp ) ;
    fwrite( &i, sizeof(int), 1, outfp ) ;
    fwrite( &label, sizeof(int), 1, outfp ) ; 
  }

  fclose( outfp ) ;

  return(1) ;

}
