/////////////////////////////////////////////////////////////////////////////////////
//
// MakeSpeakerLists.cc
//
// Holt aus der Trainingsliste (nach Sprechern sortiert!) die files der einzelnen
// Sprecher und schreibt sie in ein File, das nach dem Sprecher benannt ist!
//
/////////////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "siginput.h"

#define QUANT_BYTES 2
#define BLOCKSIZE 256


int main( int argc, char *argv[] ) {

    char line[1024] ;
    char speaker[5] ;
    char lastspeaker[5] ;
    char cdrom[128] ;
    char lastcdrom[128] ;
    long cdnr ;
    char speakerfile[128] ;
    char speakersegfile[128] ;
    char speakersignalfile[128] ;
    char *tmp ;
    char *tmp2 ;
    int i ;
    FILE *speakerFp ;
    FILE *speakerlistFp ;
    long speakerframes = 0 ;
    long speakersamples = 0 ;
    CSigInputFileILS IlsFile(BLOCKSIZE) ; // determine length of signalfile
    short *buf = new short[BLOCKSIZE*IlsFile.getBlocksPerRequest()];

    
    // check params
    if( argc != 2 ) {
	fprintf( stderr, "USAGE: %s <trainlist>\n", argv[0] ) ;
	exit(-1) ;
    } ;

    // open trainfile
    FILE *trainfp ;
    if( (trainfp = fopen( argv[1], "r" )) == 0 ) {
	fprintf( stderr, "ERROR: Fatal, can't open trainfile %s!\n", argv[1] ) ;
	exit(-1) ;
    } ;

    // open speakerlist-file
    if( (speakerlistFp = fopen( "speaker.lst", "w" )) == 0 ) {
	fprintf( stderr, "ERROR: Fatal, can't open speakerlist-file 'speaker.lst'!\n" ) ;
	exit(-1) ;
    } ;
	

    strcpy( lastspeaker, "" ) ;
    strcpy( lastcdrom, "" ) ;
    speakerFp = NULL ;
    // loop over lines of trainfile
    while( fgets( line, 1024, trainfp ) != 0 ) {
	// cut line in tokens
	// jump over first 4 entries
	strtok( line, " \t" ) ;
	for( i=0 ; i<3 ; i++ )
	    strtok( NULL, " \t" ) ;
	//fifth entry is speaker!
	strcpy( speaker, strtok( NULL, " \t" )) ;
	// 10th entry is signalfile (including path) -> cdrom-Nr is included
	for( i=0 ; i<4 ; i++ )
	    strtok( NULL, " \t" ) ;
	strcpy( speakersignalfile , strtok( NULL, " \t" )) ;
	strncpy( cdrom, speakersignalfile, strlen( speakersignalfile) - 18 ) ;

	// new speaker or same as in last line???
	if( strcmp( lastspeaker, speaker ) == 0 && strcmp( lastcdrom, cdrom ) == 0 ) {
	    // SAME SPEAKER AS IN LAST LINE
	    // get signalfilename and segmentationfilename
	    //strcpy( speakersignalfile, cdrom ) ;
	    strcpy( speakersegfile, speakersignalfile ) ;
	    speakersegfile[ strlen(speakersegfile) - 3 ] = '\0' ;
	    fprintf( speakerFp, "%sSEG-WOL3\n",  speakersegfile ) ;
	    // calculate nr of frames of signalfile
	    IlsFile.startRead( speakersignalfile ) ;
	    while( IlsFile.sigReadBlock( buf ) == 0 );
	    speakersamples += IlsFile.getSampleAnz();
	    speakerframes += (long)((IlsFile.getSampleAnz()-320) / 320) * 2 ;
	} else {
	    // NEW SPEAKER
	    // not first speaker
	    if( strcmp( lastspeaker, "" ) != 0 )
		fprintf( speakerlistFp, "frames: %d\tsamples: %d \n", speakerframes, speakersamples ) ;
	    // new speaker
	    // save old speaker and cdrom
	    strcpy( lastspeaker, speaker ) ;
	    strcpy( lastcdrom, cdrom ) ;

	    // close old speaker's file
	    if( speakerFp != 0 )
		fclose( speakerFp ) ;
	    // create new filename and open file
	    // determine cdnr 
	    tmp = strstr( cdrom, "cd" );
	    tmp += 2 ;
	    tmp2 = strtok( tmp, "//" ) ;
	    cdnr = strtol( tmp2, NULL, 10 ) ;

	    // Eintrag in Liste der Sprecher (mit CD-Nr)
	    fprintf( speakerlistFp, "%s\t%d\t", speaker, cdnr ) ;

	    // neuer Filename
	    sprintf( speakerfile, "%s_cd%d.lst", speaker, cdnr ) ;
	    if( (speakerFp = fopen( speakerfile, "w" )) == 0 ) {
		fprintf( stderr, "WARNING: Can't open speakerfile %s!\n", speakerfile ) ;
		continue ;
	    } ;
	    // reset speakerframe-count
	    speakerframes = 0 ;
	    speakersamples = 0 ;
	    // getsignalfile
	    //( speakersignalfile, cdrom ) ;
	    strcpy( speakersegfile, speakersignalfile ) ;
	    speakersegfile[ strlen(speakersegfile) - 3 ] = '\0' ;
	    fprintf( speakerFp, "%sSEG-WOL3\n",  speakersegfile ) ;
	    // add nr of frames ( samples )
	    IlsFile.startRead( speakersignalfile ) ;
	    while( IlsFile.sigReadBlock( buf ) == 0 );
	    speakersamples += IlsFile.getSampleAnz();
	    speakerframes += (long)((IlsFile.getSampleAnz()-320) / 320) * 2 ;
	} ;

    } ;

    // print nr of frames and samples for last speaker!
    fprintf( speakerlistFp, "frames: %d\tsamples:%d \n", speakerframes, speakersamples ) ;


    if( buf != 0 )
	delete buf ;

    if(  speakerFp != 0 )
	fclose( speakerFp ) ;

    if( trainfp != 0 )
	fclose( trainfp ) ;

    if( speakerlistFp != 0 )
	fclose( speakerlistFp ) ;

} ;

