/******************************************************************************
 * file:        akup_muc.h  (for akupre.cc, TU-Muenchen Vorverarbeitung)
 * info:        class declarations for CAkuPre, acoustic preprocessing 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 *
 * Die Implementierung realisiert ein innerhalb des Projekts VERBMOBIL  
 * entwickeltes Signalanalyseverfahren, da"s an der TU-Muenchen erg"anzt und 
 * neu implementiert wurde.
 *
 * Die Software ist ausschlie"slich f"ur die Verwendung innerhalb des Projektes
 * VERBMOBIL bestimmt. Eine Weitergabe der Programme an Partner au"serhalb des 
 * Projektes VERBMOBIL ist nur mit Zustimmung des Lehrstuhls MMK der TU
 * Muenchen zul"assig. 
 * 
 * Das Projekt VERBMOBIL wird vom Bundesminister f"ur Forschung und Technologie
 * unter dem F"orderkennzeichen 01IV 102K gef"ordert.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

/******************************************************************************

CLASS 'CAkuPre':

Beschreibung siehe: _readme

 ******************************************************************************/


#if !defined( _AKUPRE_H_ )
#define _AKUPRE_H_

#include <stdio.h>

#include "pref_muc.h"

#include "dbg_mess.h"
#include "siganl.h"
//#include "chancomp.h"
#include "paramet.h"

enum ERdFlag    { Undef, Wanted, NotWanted };

// class definition for CAkuPre
class CAkuPreSimpleFile
{
private:
  // readable parameter for akupre
  CParString         DeviceStr;

  CParInt    FeatVecLen ;
  float     *featvecp ;

  FILE *datafp ;
  int   NrFrames ;
  int   FrameDist ;
  short VecLen ;
  short ParmKind ;

public:
   CAkuPreSimpleFile( const char *cfgfile );
  ~CAkuPreSimpleFile();
   int            startAkuPre( const char *filename );
   void           stopAkuPre();
   void           clearAkuPre();
  //SFeature      *getNext();
   float*         getNextPre();
};


#endif

