/******************************************************************************
 * file:        chancomp.h  (for chancomp.cc)
 * info:        class declarations for CPreFeature 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

#if !defined( _CHANCOMP_H_ )
#define _CHANCOMP_H_

#include <stdio.h>
#include "paramet.h"
#include "feature.h"

// class CChanComp:  spectral channel adaptation
class CChanComp
{
private:
    const unsigned int  NrChannels;
    CParBool            TrainFlag;
    CParBool            UpdateFlag;
    CParBool            UpdateWrite;
    CParEnum            UpdateUse;
    CParFloat           UpdateTau;

    const float         bFactor;
    const float         aFactor;
    const float         cFactor;

    CParFloatVec        CurMean;
    CParFloatVec        CurVar;
    CParFloatVec        TrainMean;
    CParFloatVec        TrainVar;

    unsigned long       NrVectors;
    FILE               *ChanFile;
public:
    CChanComp( unsigned int speclen, FILE *file, double dt ); 
    ~CChanComp();
    void  subMean( float *spec, ESpeechFlag flag );
    int   writePar( FILE *fp );
    int   appendUpdPar( FILE *fp );
    int   appendFixPar( FILE *fp );
};


#endif

