/******************************************************************************
 * file:        cctrain.cc  (main)
 * info:        training of channel compensation means and vars 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/
/* 
Beschreibung:    
  
*/

#include <stdio.h>
#include <string.h>

#include "dbg_mess.h"
#include "akupre.h"

#define   MAXCATLINELEN  256

//------------------------------- main ----------------------------------------

// main prg.
int main( int argc, char *argv[] )
{
    // open files
    if( argc != 3) 
    {   fprintf(stderr,"usage: chctrain <channel-file> <catalog-file>\n");
        return _ERR_;
    }
    FILE *chanfp = fopen( argv[1], "r+" );
    IF_ERROR_RETURN_S( chanfp == 0, "can't open channel-file:", argv[1]);
    FILE *catfp = fopen( argv[2], "r" );
    IF_ERROR_RETURN_S( catfp == 0, "can't open catalog-file:", argv[2] );

    // construct
    CAkuPre    AkuPre( chanfp );

    // loop over catalog
    char  str[MAXCATLINELEN], *sigfilename;
    while( fgets( str, MAXCATLINELEN, catfp) != 0 )
    {   if( (sigfilename = strtok(str, " ,\t\n")) == 0) break;
 
        // start AkuPre
        if( AkuPre.startAkuPre( sigfilename ) == _ERR_ ) continue;

        // update proc. loop
        SFeature *fp;
        while( AkuPre.testRdIsRun() )
        {   if( (fp=AkuPre.getNext()) == 0 ) 
                continue; 
        }

        // clear AkuPre
        AkuPre.clearAkuPre();
    }

    return _OK_;
}
