/******************************************************************************
 * file:        fft.h  (for fft.cc)
 * info:        class declarations for CFastFourier (FFT)
 * written by:  M.Beham, 12.01.95 (org. from fft.c)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

#if !defined( _FFT_H_ )
#define _FFT_H_


// class definition for CFastFourier

class CFastFourier
{
private:                                             // FFT-parameter
    const unsigned int  Order;                          // window length = 2^order
    const unsigned int  Len;                            // window length
    float *BfRePtr;                                     // table of butterfly operators (real) length = Len/2
    float *BfImPtr;                                     //   "   (imag)
    unsigned short *SpBitPtr;                           // bit revers order table length = Len
public:                                              // member functions
    CFastFourier(unsigned int winlen );                 // init of butterfly table
   ~CFastFourier();                                     // free of   "
    void transform( float *RePtr, float *ImPtr );       // FFT transformation of real and imag. vectors
    void invers( float *RePtr, float *ImPtr );          // invers transformation
};


#endif

