/******************************************************************************
 * file:        hamming.h  (for hamming.cc)
 * info:        class declarations for CHammingWindow 
 * written by:  M.Beham, 12.01.95 (org. from sts.c)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

#if !defined( _HAMMING_H_ )
#define _HAMMING_H_


// class definition for CHammingWindow

class CHammingWindow
{
private:
    const unsigned int  Len;
    float              *WinDataPtr;
    float               NormFactor;
    float               WinAverage;
public:
    CHammingWindow( unsigned int len, double norm = 1.0 );
   ~CHammingWindow();
    void     mult( float *sig );
    void    dcSub( float *sig );
    float countZC( float *sig );
    void  setNorm( double norm);
};

#endif

