/******************************************************************************
 * file:        ilshead.h  
 * info:        struct declaration of ILS-file header 'SHeaderILS'
 * written by:  M.Beham, 12.01.95 (org. from ils.h)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/
/******************************************************************************
 * Die Definition des ILS-Headers stammt aus einem Forschungsbericht des
 * Instituts fuer Phonetik und sprachliche Kommunikation der Universitaet
 * Muenchen:
 * 
 * PhonDat,  Verbundvorhaben zum Aufbau einer Sprachsignaldatenbank fuer
 *           gesprochenes Deutsch
 * 
 * BMFT Foerderkennzeichen 01IV 103
 * 
 * Die Software ist ausschlie"slich fuer die Verwendung innerhalb des Projekts  
 * VERBMOBIL bestimmt. Eine Weitergabe der Programme an Partner au"serhalb des 
 * Projektes VERBMOBIL ist nur mit Zustimmung der beteiligten Institute 
 * zulaessig. 
 * Das Projekt VERBMOBIL wird vom Bundesminister fuer Forschung und Technologie
 * unter dem F"orderkennzeichen 01IV 102K gef"ordert.
 ******************************************************************************/
struct SHeaderILS 
{
long int     dummy1[5];
long int     nspbk;
long int     anz_header;     // Anz. der folg. 512 Byte Header
long int     dummy2[5];
long int     ifld[4];
long int     dummy3[6];
char         id[16];
long int     dummy4[35];
long int     isf;           // SampleFrq. in Hz
long int     flag_type;     // = -32000 (ILS-Samplefile)
long int     flag_init;     // = 32149 , falls Init.
char         ifl[32];
struct 
{   char     day;
    char     month; 
    short    year;
}            date;	    // Datum 
char         mw;	    // Geschlecht
char         version;	    // Header-Version 0,1 = ILS Header; 2 = mult.Header
short int    adc_bits;
short int    words;         // Anzahl Worte im Text
char         asc_text[200];
short int    wdh;
short int    abs_ampl;
char         dummy5[10];
};
