/******************************************************************************
 * file:        nisthead.h  
 * info:        struct declaration of NIST-file header 'SHeaderNIST'
 * written by:  M.Beham, 12.01.95 (org. from ils.h)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1998 T. Pfau
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/
/******************************************************************************
 * 
 * BMFT Foerderkennzeichen 01IV 103
 * 
 * Die Software ist ausschlie"slich fuer die Verwendung innerhalb des Projekts  
 * VERBMOBIL bestimmt. Eine Weitergabe der Programme an Partner au"serhalb des 
 * Projektes VERBMOBIL ist nur mit Zustimmung der beteiligten Institute 
 * zulaessig. 
 * Das Projekt VERBMOBIL wird vom Bundesminister fuer Forschung und Technologie
 * unter dem F"orderkennzeichen 01IV 102K gef"ordert.
 ******************************************************************************/

#ifndef NISTHEADERINCLUDED
#define NISTHEADERINCLUDED

#ifndef STRLEN
#define STRLEN 64 
#endif

#ifndef MaxLineLength
#define MaxLineLength 255
#endif

struct SHeaderNIST {
    char head[STRLEN];
    int  size ;
    char database[STRLEN] ;
    char version[STRLEN] ;
    char reclanguage[STRLEN] ;
    char scenario[STRLEN] ;
    char dialogid[STRLEN] ;
    char speaker[STRLEN] ;
    char site[STRLEN] ;
    char recmedium[STRLEN] ;
    char recmedspec[STRLEN] ;
    char samplecod[STRLEN] ;
    int sample_n_bytes ;
    int channel ;
    int samples ;
    int sample_sig_bits ;
    char byteformat[STRLEN] ;
    int samplerate ;
    char scenariodate[STRLEN] ;
} ;
 

#endif
