/******************************************************************************
 * file:        siganl.h  (for siganl.cc)
 * info:        class declarations for CSigAnalyse 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

#if !defined( _SIGANL_H_ )
#define _SIGANL_H_

#include "sigwin.h"
#include "specdoub.h"

// class definition for CSigAnalyse

class CSigAnalyse
{
private:
    CSigWinBuffer      Sig;
    CSpecDoubleBuf     Spec;
    int                NextIndex;       
public:
   CSigAnalyse( unsigned int windelta, unsigned int winlen, unsigned int fftlen, char *devicestr, 
		int sampleshift, float preemphase );
   ~CSigAnalyse();
   int    startAnl( const char *filename, int skipbytes=0 );
   void   clearAnl();
   void   stopAnl();
   float *getNextSpec( );
   float *getNextSpec( float *zcr );
     int    getSampleAnz() const { return Sig.getSampleAnz(); }
   int    getWindowAnz() const { return Sig.getWindowAnz(); }
   void   normWindow( double norm ) { Spec.setNorm(norm); }
   unsigned int getFrqSamp() const { return Sig.getFrqSamp(); } 
};


#endif

