/******************************************************************************
 * file:        sigwin.h  (for sigwin.cc)
 * info:        class declarations for CSigWinBuffer 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/

#if !defined( _SIGWIN_H_ )
#define _SIGWIN_H_

#include "siginput.h"


// class definition for CSigWinBuffer

class CSigWinBuffer
{
private:
    const unsigned int  BufLen;
    const unsigned int  WinLen;
    const unsigned int  MinBufFill;
    const unsigned int  SampleShift;
    const float         Preemphase;
    unsigned int        BufAnz;
    unsigned int        BufFill;
    unsigned int        WinNum;
    // float signal Buffer
    float              *BasePtr;
    float              *EndPtr;
    float              *WPtr;
    float              *RPtr;
    // sample buffer
    short              *SampleBuf;

    CSigInput          *SigInputPtr;       
    int fillBuf( float *dest );
public:
   CSigWinBuffer( unsigned int windelta, unsigned int winlen, char *devicestr, int samshift, float preem );
   ~CSigWinBuffer();
   int    startBuf( const char *filename, int skipbytes=0 );
   void   clearBuf();
   void   stopBuf();
   int    getWin( float *destptr );
   int    getSampleAnz() const { return SigInputPtr->getSampleAnz(); }
   int    getWindowAnz() const { return WinNum; }
   unsigned int getFrqSamp() const { return SigInputPtr->getFrqSamp(); }
};


#endif

