/******************************************************************************
 * file:        spdonl.cc  (main)
 * info:        testing of speech / non-speech detector (online) 
 * written by:  M.Beham, 12.01.95 (new)
 * last change: 
 * 
 ******************************************************************************/
/******************************************************************************
 *
 * Copyright (C) 1995 M. Beham
 *                                                                   
 * Alle Rechte vorbehalten. Diese Programmlistings und das daraus
 * erhaltene Programm duerfen nur mit schriftlicher Genehmigung	
 * des Autors weitergegeben werden.
 * Insbesondere duerfen auch Auszuege und die daraus erhaltenen
 * Programmteile nur mit schriftlicher Genehmigung des Autors
 * weitergeben, geaendert oder in Programmen anderer Autoren
 * verwendet werden.
 * Diese Copyright-Information darf nicht entfernt oder geaendert
 * werden.
 * 
 ******************************************************************************/
/* 
Beschreibung:    
  
*/

#include <stdio.h>
#include <string.h>
#include <signal.h>
//#include <task.h>
#include "/usr/local/opt/SUNWspro/SC4.0/include/CC/task.h"
#include <unistd.h>

#include "dbg_mess.h"
#include "akupre.h"



//------------------------------- signal SIGINT handler -----------------------

class CSigIntHandler : public Interrupt_handler
{
private:
    int   IntFlag;
    void  interrupt() { IntFlag = TRUE; }
public:
    CSigIntHandler() : Interrupt_handler(SIGINT), IntFlag(FALSE) {}
    int &isSet() { return IntFlag; }
};

//------------------------------- main ----------------------------------------

// main prg.
int main( int argc, char *argv[] )
{
    // open files
    if( argc < 2 || argc > 3 ) 
    {   fprintf(stderr,"usage: spdonl <channel-file> [-s/-p]\n");
        return _ERR_;
    }
    FILE *chanfp = fopen( argv[1], "r+" );
    IF_ERROR_RETURN_S( chanfp == 0, "can't open channel-file:", argv[1]);

    ESpeechFlag  trainflag = U;
    char *fname = " ";

    if( argc == 3 )
    {   if( argv[2][0] == '-' )
        {    if(      argv[2][1] == 's' ) trainflag = S;
             else if( argv[2][1] == 'p' ) trainflag = P;
        } else
           fname = argv[2];
    }

    // sigint receive
    CSigIntHandler  IntHandler;

    // construct
    CAkuPre    AkuPre( chanfp );

    char  *fstr = "\r>         >                                        ";
    char  *ustr = "\n P..:..S   0...1...2...3...4...5...6...7...8...9.\n";

    // start AkuPre
    if( AkuPre.startAkuPre( fname ) == _ERR_ ) exit(0);
    IntHandler.isSet() = FALSE;
    printf(ustr); fflush(stdout);
    SFeature *featp;
    SPreFeature *prefp;
    int  spflag, eact, emax, isp;
    while( AkuPre.testRdIsRun() )
    {   if( trainflag == U )
        {   featp = AkuPre.getNext();
            if( featp == NULL ) continue;
            prefp = &featp->Pre;
            spflag = AkuPre.getRdFlag();
        } else
        {   prefp = AkuPre.getNextPre();
            if( prefp == NULL ) continue;
            AkuPre.updateSpNonSp( prefp, trainflag );
            spflag = trainflag;
        }
        isp    = (spflag < 4 ? (spflag == 0 ? 3 : spflag - 1 ) : spflag) + 2; 
        eact   = (int)(prefp->TotalEnergy * 0.4 + 0.5);
        emax   = (int)(AkuPre.getRdMax()[0]   * 0.4 + 0.5);
        if( eact > 37 ) eact = 37;
        if( emax > 37 ) emax = 37;
        eact += 12;
        emax += 12;
        fstr[isp] = '*';
        fstr[eact] = '*';
        fstr[emax] = '|';
        printf(fstr);
        fflush(stdout);
        fstr[emax] = fstr[eact] = fstr[isp] = ' ';
        if( IntHandler.isSet() ) break;
    }
       

    // clear AkuPre
    AkuPre.clearAkuPre();

    return _OK_;
}
