#include "akupresimple.h"
#include "spnonsp.h"

#define TEST



int nrframe ;
ESpeechFlag *SpeechFlag ;

char* speechlabel = "S" ;
char* nonspeechlabel = ".." ;



void PrintTrs( char *filename ) {

  int i,count, frame ;

  FILE *globoutfp = fopen( filename, "w" ) ;
  if( globoutfp == 0 ) {
    fprintf( stderr, "WARNING: can't open file '%s', using stdout instead!\n" ) ;
    globoutfp = stdout ;
  } ;

  // print header:
  fprintf( globoutfp, "<?xml version=\"1.0\"?>\n" ) ;
  fprintf( globoutfp, "<!DOCTYPE Trans SYSTEM \"trans-13.dtd\">\n" ) ;
  fprintf( globoutfp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
  fprintf( globoutfp, "<Episode>\n" ) ;
  fprintf( globoutfp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", nrframe/100.0 ) ;
  fprintf( globoutfp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", nrframe/100.0 ) ;


  // first loop: convert 'U' to S or P 
  ESpeechFlag last = P ;
  ESpeechFlag next = U ;

  // first frame:
  if( SpeechFlag[0] == U )
    SpeechFlag[0] = P ;

  // last frame:
  if( SpeechFlag[nrframe-1] == U )
    SpeechFlag[nrframe-1] = P ;

  for( frame = 1 ; frame < nrframe ; frame ++ ) {
    if( SpeechFlag[frame] == U ) {

      if( next == U ) {
	// search for next valid decision:
	for( i=frame ; i<nrframe ; i++ ) {
	  if( SpeechFlag[i] != U ) {
	    next = SpeechFlag[i] ;
	    break ;
	  }
	}

      }

      SpeechFlag[frame] = next ;

      //if( last == P && next == P )
      //SpeechFlag[frame] = P ;
      //else
      //SpeechFlag[frame] = S ;      
   
    } else {
      next = U ;
    } ;

    last = SpeechFlag[frame] ;

    //fprintf( stdout, "%d\n", SpeechFlag[frame] ) ;

  } ;
  
  // second loop: print chunks in trs-format:
  last = U ;
  for( frame = 0 ; frame < nrframe ; frame ++ ) {
    if( SpeechFlag[frame] != last ) {
      // new chunk: either S or NS
      fprintf( globoutfp, "<Sync time=\"%.3f\"/>\n", frame/100.0 ) ;
      fprintf( globoutfp, "%s\n", ( SpeechFlag[frame] == S ? speechlabel : nonspeechlabel ) );

      last = SpeechFlag[frame] ;
    }
  } ;

  fprintf( globoutfp, "</Turn>\n" ) ;
  fprintf( globoutfp, "</Section>\n" ) ;
  fprintf( globoutfp, "</Episode>\n" ) ;
  fprintf( globoutfp, "</Trans>\n" ) ;

  if( globoutfp != stdout )
    fclose( globoutfp ) ;
}

int main( int argc, char *argv[] ) {

  int MaxNrFrames = 10000 ;
  int frame, tmpframe ;
  int maxshift = 0, maxshiftframe=0, count=0 ;
  ESpeechFlag lastflag = P ;

  // check params:
  if( argc < 4) {
    fprintf( stderr, "USAGE: %s <spnonsp-cfg-file> <apostfile> <outfile> [MaxNrFrames=10000]\n", argv[0] ) ;
    exit(-1) ;
  }

  FILE *sns_cfg_fp = fopen( argv[1], "r" ) ;
  if( sns_cfg_fp == 0 ) {
    fprintf( stderr, "Can't open sns cfg file %s\n", argv[1] ) ;
    exit(-1) ;
  } ;

  char* outfile = new char[strlen(argv[3])+1] ;
  strcpy( outfile, argv[3] ) ;

  if( argc == 5 ) 
    MaxNrFrames = strtol( argv[4], NULL, 10 ) ;

  // do S/NS decision and store it
  CSpeechNonSpeechANN SpNonSp( (double)WINDOW_DELTA/(double)SAMPLE_FRQ , sns_cfg_fp ) ;
  SpeechFlag = new ESpeechFlag[MaxNrFrames] ;

  SpNonSp.start(argv[2]) ;

  nrframe = MaxNrFrames ;

  // loop over all frames, do detection:
  for( frame = 0 ; frame<MaxNrFrames ; frame++ ) {
    SpeechFlag[frame] = SpNonSp.detect() ;
    if( SpeechFlag[frame] == INVALID ) {
      nrframe = frame ;
      break ;
    };

    //fprintf( stdout, "%d\n", SpeechFlag[frame] ) ;

    //if( SpeechFlag[frame] == U ) {
    //  count++ ;
    //  SpeechFlag[frame] = S ;
    //} ;
  } ;
  
  PrintTrs( outfile ) ;


  //for( frame=0 ;frame<nrframe ; frame++ ) {
  //fprintf( stdout, "[%d] %d\n", frame, SpeechFlag[frame] );
  // }

  delete[] outfile ;
  delete[] SpeechFlag ;

  return(1) ;
}
