#include <stdio.h>
#include <string.h>
#include <math.h>

#include "genobj.h"

#include "paramet.h"
#include "lab_list.h"

#include "dbg_mess.h"
#include "akupresimple.h"
#include "spnonsp.h"

#include "p_histo.h"

//#include "corcoeff.h"

#define   MAXCATLINELEN  256
#define   DMAX  50
#define   OUTPUT_LOG
//#define   ENERGYMIN 1.0 

#define MAXNRCHAN 20

// use first 120 minutes ONLY!
#define MAXFRAMESFORMAXDET 1080000  
#define SPURTLENFORMAXDET  1080000
#define SKIPLEN 0
//#define MINSKIP 60000
//#define MINSKIP 0
//#define MINSPURTLEN 10
//#define MINSPURTLEN 6000
//#define MINNRSPURT 5
//#define MINNRSPURT 5

//#define TESTSECPASS_LOW
//#define TEST_SECPASS_HIGHLEVEL
#define TESTLEVEL
//#define TEST_HIGHLEVEL
//#define TESTLEVEL2
//#define LOG_CORREL
//#define TEST_SENS
//#define TEST_SECPASS

//#define TEST_ALPHA

#define TEST_CORREL

//#define TEST_ENTROPY 


//--------------------------------- CTool object ------------------------------

class CTool
{
public:
    CParString         LabelKeyword;
  //CParString         LabelSilentBeg;
  //CParString         LabelSilentEnd;
    CTool( FILE *fp );
};

CTool::CTool( FILE *fp )
  :   LabelKeyword( "Tools.Label.Keyword", fp, "???" )
  //LabelSilentBeg(  "Tools.Label.SilentNameBeg", fp, "sw_/" ),    
  //LabelSilentEnd(  "Tools.Label.SilentNameEnd", fp, "sw_\\" )
{  ; } ;

#ifndef OutPutModeDef
typedef enum { FrameWise, MUC, XML, MUC_OLD, XML_MULT } EOutPutMode ; 
#define OutPutModeDef
#endif


//------------------------------- global variables ----------------------------------------

float **Energy=0 ;                    // array of energies for each frame and channel
//float **EnergyNoSmooth=0 ;            // array of energies for each frame and channel, always contains unsmoothed energies
float **ModLoud=0 ;                   // array of modified loudness for each frame and channel
float **SumLoud=0 ;                   // array of modified loudness for each frame and channel
ESpeechFlag **SpeechFlag=0  ;          // array of decisions of spnonsp-detector for each frame and channel
ESpeechFlag **SpeechFlag2=0  ;         // array of decisions of spnonsp-detector for each frame and channel, second pass!
ESpeechFlag **SpeechFlagOut=0  ;         // array of decisions of spnonsp-detector for each frame and channel, second pass!
float **Sens;                          // adjust sensitivity (priors) for second S/NS pass
int *Channel=0 ;                       // array of active ChannelId for each frame, contains ChanId or -1 
//int **ChannelNoSmooth=0 ;            // array of active Channel-Ids for each frame, built on the basis of EnergyNoSmooth[][] 
CAkuPreSimple **AkuPre=0 ;             // array of pointers to acoustic preprocessing of the indiv channels
//CAkuPreSimple  *AkuPreMixFile=0 ;      // pointer to acoustic preprocessing of mixfile 
CAkuPreSimple  **AkuPrePZMFile=0 ;     // pointer to acoustic preprocessing of mixfile 
CSpeechNonSpeechANN **SpNonSp=0  ;      // array of pointers to speechnonspeech-detectors for indiv channels
CSpeechNonSpeechANN **SpNonSp2=0  ;     // array of pointers to speechnonspeech-detectors for indiv channels for second pass
float **LogSp ;                         // array for log speech prob of each frame and chan
float **LogSi ;                         // array for log silence prob of each frame and chan
//CSpeechNonSpeechANN *SpNonSpMixFile=0; // pointer to speechnonspeech-detector of mixfile
CTool *Tool=0 ;                        // pointer to Tool-class

CSigWinBuffer **SigWin=0 ;             // array of pointers to sigwinbuffer of all channel-files (to compute correlations!)
float **Correl ;                       // array of framewise correlations between channels 
float **CorrelPZM ;                    // array of framewise correlations between each channel and the PZM files used 

FILE **outfp=0 ;                       // filepointer for output of results for indiv channels
FILE *globoutfp=0 ;                    // filepointer for out of single resultfile
FILE *chanfp=0 ;                       // filepointer to basic cfg-file containing unchangeable params
FILE *spnonspchancfgfp=0;              // filepointer to cfg-file for spnonsp-detector of indiv channels (containing means and vars!)
FILE *spnonspchancfgfp2=0;             // fileptr to cfg-file for spnsp-det. of indiv channels (cont. means and vars!), more sensitive version
//FILE *spnonspmixcfgfp=0;               // filepointer to cfg-file for spnonsp-detector of mixfile (containing means and vars!)
FILE *logfp ;

SPreFeature **prefp=0 ;                // array of pointers to feature vectors of indiv channels
//SPreFeature *prefpmixfile=0 ;          // pointer to feature vector of mixfile
SPreFeature **prefppzmfile=0 ;         // pointer to feature vector of mixfile

float meanenergy ;                     // meanenergy of current frame of all channels (including mixfile)
float meanenergyohnemix ;              // meanenergy of current frame of all channels (without mixfile)
float *energymin=0  ;                  // array of minimum energies found on each channel
float *sumloudmax=0 ;                  // array of max sumloudness found on each channel
float *sumloudmin=0 ;                  // array of max sumloudness found on each channel
float *modloudmax=0 ;                  // array of max modified loudness found on each channel
float *modloudmin=0 ;                  // array of max modified loudness found on each channel
//float *zcratemax=0 ;                 // array of max zerocrossingrate found on each channel
float *zcratemin=0 ;                   // array of max zerocrossingrate found on each channel

float *Entropy_close ;
float *Entropy_lapel ;

int nrchanwav ;                        // number of indiv channels (without mixfile)
int nrframe ;                          // number of frames of wavfiles (shortest wavfile should be counted!)

int wavfileoffset ;                    // index of first wavfile-argument
//int mixfileindex ;                     // index of mixfile-argument
int outfileindex ;                     // index of outfile-argument
int pzmfileindex ;                     // index of pzmfile-argument
int tmppathindex ;

int nrpzm ;                            // number of pzmfiles used
int nrskip ;                           // number of frames to skip at the beginning of wavfiles!

int **ChanCount=0 ;                    // contains, how often a channels is the most probable within a smoothbuffer!
//int *Overlap=0 ;                     // info about overlap for each channel (while output is produced!
//int **OverlapFlag=0 ;                  // info about S/NS for each channel

char **ChanId ;                        // array of strings which contain the ChannelId of each channel (Ids 0,1,2, ...,A,B)
char **PZMId ;                         // array of strings which contain the ChannelId of each pzm channel (Ids 6,7,C,D,E,F)
int *ByteSkip ;                        // array with values of nr of bytes to skip at beg of each signal file
int *ByteSkipPZM ;                     // array with values of nr of bytes to skip at beg of each signal file (for PZMs)

//------------------------------- functions ----------------------------------------

void PrintSpeechFlagArray( FILE *fp ) {

  // local variables 
  int chan, frame, count ;
  
  for( frame=0 ; frame<nrframe ; frame++ ) {
    count = 0 ;
    for( chan=0 ;chan<nrchanwav+1 ; chan++ ) {
      fprintf( fp, "%d: %d\t", frame, SpeechFlag[frame][chan] ) ;
      if( SpeechFlag[frame][chan] >= PUS ) 
	count++ ;
    } ;
    fprintf( fp, "nract: %d\n", count ) ;
  } ;
} ;

void PrintChannelArray( FILE *fp ) {

  // local variables 
  int chan, frame ;
  
  for( frame=0 ; frame<nrframe ; frame++ ) 
    fprintf( fp, "%d: %d\n", frame, Channel[frame] ) ;

} ;


void PrintEnergyArray( FILE *fp ) {

  // local variables 
  int chan, frame ;
  
  for( frame=0 ; frame<nrframe ; frame++ ) {
    for( chan=0 ;chan<nrchanwav+1 ; chan++ ) {
      fprintf( fp, "%d: %f\t", frame, Energy[frame][chan] ) ;
    } ;
    fprintf( fp, "\n" ) ;
  } ;
} ;

void PrintCorrelationArray( FILE *fp, int frames ) {

  // local variables 
  int chan1, chan2, n=0, frame ;
  
  for( frame=0 ; frame<frames ; frame++ ) {
    n=0 ;
    for( chan1=0 ;chan1<nrchanwav ; chan1++ ) {
      for( chan2=chan1+1 ; chan2<nrchanwav ; chan2++ ) {
	fprintf( fp, "%d: %f\t", frame, Correl[frame][n] ) ;
	n++ ;
      }
    } ;
    fprintf( fp, "\n" ) ;
  } ;
} ;

void PrintPZMCorrelationArray( FILE *fp, int frames ) {

  // local variables 
  int chan, pzm, frame ;
  
  for( frame=0 ; frame<frames ; frame++ ) {
    for( chan=0 ;chan<nrchanwav ; chan++ ) {
      for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
	fprintf( fp, "%d: %f\t", frame, CorrelPZM[frame][chan*nrpzm+pzm] ) ;
      }
    } ;
    fprintf( fp, "\n" ) ;
  } ;
} ;





void PrintModLoudArray( FILE *fp ) {

  // local variables 
  int chan, frame ;
  
  for( frame=0 ; frame<nrframe ; frame++ ) {
    for( chan=0 ;chan<nrchanwav+1 ; chan++ ) {
      fprintf( fp, "%d: %f\t", frame, ModLoud[frame][chan] ) ;
    } ;
    fprintf( fp, "\n" ) ;
  } ;
} ;




void SmoothEnergies( int delta ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Smooth Energies (buflen: %d)\n", 2*delta+1 ) ;
#endif

  // local variables
  float sum ;
  int j, frame, chan, tmpframe ;  

  for( frame=0 ; frame<nrframe ; frame++ ) {
    
    for( chan=0 ; chan<nrchanwav+1 ; chan++ ) {
      sum = 0.0 ;
      for( j=-delta ; j<=delta ; j++ ) {
	if( (tmpframe = frame+j) < 0 )
	  tmpframe = 0 ;
	if( tmpframe >= nrframe )
	  tmpframe = nrframe-1 ;
	
	sum += Energy[tmpframe][chan] ;
      } ;
      Energy[frame][chan] = sum/(2*delta+1) ;
    } 
  } ;
} ;


void SmoothModLoud( int delta ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Smooth ModLoud (buflen: %d)\n", 2*delta+1 ) ;
#endif


  // local variables
  float sum ;
  int j, frame, chan, tmpframe ;  

  for( frame=0 ; frame<nrframe ; frame++ ) {
    
    for( chan=0 ; chan<nrchanwav+1 ; chan++ ) {
      sum = 0.0 ;
      for( j=-delta ; j<=delta ; j++ ) {
	if( (tmpframe = frame+j) < 0 )
	  tmpframe = 0 ;
	if( tmpframe >= nrframe )
	  tmpframe = nrframe-1 ;
	
	sum += ModLoud[tmpframe][chan] ;
      } ;
      ModLoud[frame][chan] = sum/(2*delta+1) ;
    } 
  } ;
} ;



int CountFrames(  char **argument ) {

  // local variables
  int count ;
  
#ifdef TESTLEVEL
  fprintf( stderr, "Determine length of signal-files ...\n" ) ;
#endif
  // start akupre of first wavfile
  AkuPre[0]->clearAkuPre() ;
  AkuPre[0]->startAkuPre( argument[wavfileoffset], ByteSkip[0] ) ;

  // count frames
  count = 0 ;
  while( AkuPre[0]->getNextPre() != 0 ) {
    count++ ;
  } ;

  // restart first wavfile
  AkuPre[0]->clearAkuPre() ;
  AkuPre[0]->startAkuPre( argument[wavfileoffset], ByteSkip[0] ) ;
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
  
  return( count ) ;
  
} ;


int CountFramesFast(  char **argument ) {

  // local variables
  int count ;
  
#ifdef TESTLEVEL
  fprintf( stderr, "Determine length of signal-files ...\n" ) ;
#endif

  FILE *tmp = fopen( argument[wavfileoffset], "r" ) ;

  count = (fseek( tmp, 0, SEEK_END ) - 1024) / 2 ;

#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
  
  return( count ) ;
  
} ;



void PrintHeader( EOutPutMode outputmode, int realid=0, int indivout=0 ) {
  // local variables
  int i ;

  

  // output header
  switch( outputmode ) {
    
  case FrameWise:
    for( i=0 ; i<nrchanwav ; i++ ) 
      fprintf( outfp[i], "FILENAME: %s\n", "dummy.wav" ) ;
    break ;
      
  case XML:
    for( i=0 ; i<nrchanwav ; i++ ) { 
      // dummy header: length of file is still unknown!
      fprintf( outfp[i], "<?xml version=\"1.0\"?>\n" ) ;
      fprintf( outfp[i], "<!DOCTYPE Trans SYSTEM \"trans-13.dtd\">\n" ) ;
      fprintf( outfp[i], "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
      fprintf( outfp[i], "<Episode>\n" ) ;
      fprintf( outfp[i], "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
      fprintf( outfp[i], "<Turn startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    } ;
    // dummy header: length of file is still unknown!
    fprintf( globoutfp, "<?xml version=\"1.0\"?>\n" ) ;
    fprintf( globoutfp, "<!DOCTYPE Trans SYSTEM \"trans-13.dtd\">\n" ) ;
    fprintf( globoutfp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
    fprintf( globoutfp, "<Episode>\n" ) ;
    fprintf( globoutfp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    fprintf( globoutfp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    break ;
  case XML_MULT:
    if( indivout ) { 
      for( i=0 ; i<nrchanwav ; i++ ) { 
	// dummy header: length of file is still unknown!
	fprintf( outfp[i], "<?xml version=\"1.0\"?>\n" ) ;
	fprintf( outfp[i], "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
	fprintf( outfp[i], "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
	fprintf( outfp[i], "<Episode>\n" ) ;
	fprintf( outfp[i], "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
	fprintf( outfp[i], "<Turn startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
      } ;
    }
    // dummy header: length of file is still unknown!
    fprintf( globoutfp, "<?xml version=\"1.0\"?>\n" ) ;
    fprintf( globoutfp, "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
    fprintf( globoutfp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
    fprintf( globoutfp, "<Episode>\n" ) ;
    fprintf( globoutfp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    fprintf( globoutfp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    break ;
  } ; 
} ;

void PrintIntermediateHeader( EOutPutMode outputmode, FILE *fp ) {
  // local variables
  int i ;

  // output header
  switch( outputmode ) {
    
  case FrameWise:
  
    break ;
      
  case XML:

    break ;
  case XML_MULT:
    // dummy header: length of file is still unknown!
    fprintf( fp, "<?xml version=\"1.0\"?>\n" ) ;
    fprintf( fp, "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
    fprintf( fp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
    fprintf( fp, "<Episode>\n" ) ;
    fprintf( fp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    fprintf( fp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", 0.0 ) ;
    break ;
  } ; 
} ;


void GetMinAndMax( float normchanperc=0.0 ) {

  // local variables
  int i, j, frame, running, chan, nrframesformaxdet, pzm, usedframes=-1 ;

  int MinMaxBeg = nrframe/5 ;
  int MinMaxRunLen = nrframe/20 ;
  int MinMaxNrRuns = 4 ;
  int MinMaxSkipBetween = nrframe/5 ;
 
  int *RunStart = new int[MinMaxNrRuns] ;
  int *RunEnd = new int[MinMaxNrRuns] ;
  int atend, atbeg, inrun, nrrun ;

  for( i=0 ; i< MinMaxNrRuns ; i++ ) {
    RunStart[i] = MinMaxBeg + i*MinMaxSkipBetween ;
    RunEnd[i] = MinMaxBeg + i*MinMaxSkipBetween + MinMaxRunLen -1 ;
#ifdef TEST_RUNS
    fprintf( stderr, "MinMax: RunStart[%d]: %d, RunEnd[%d]: %d\n",i, RunStart[i], i, RunEnd[i] ) ;
#endif
  } ;

  float *energymintmp = new float[nrchanwav+nrpzm] ;
  float *zcratemintmp = new float[nrchanwav+nrpzm] ;
  float *modloudmintmp = new float[nrchanwav+nrpzm] ;
  float *sumloudmintmp = new float[nrchanwav+nrpzm] ;
  float *modloudmaxtmp = new float[nrchanwav+nrpzm] ;
  float *sumloudmaxtmp = new float[nrchanwav+nrpzm] ;
  float *modloudmaxspurt = new float[nrchanwav+nrpzm] ;
  float *sumloudmaxspurt = new float[nrchanwav+nrpzm] ;
  
  // allocate size of global arrays
  energymin = new float[nrchanwav+nrpzm] ;
  sumloudmax = new float[nrchanwav+nrpzm] ;
  sumloudmin = new float[nrchanwav+nrpzm] ;
  modloudmax = new float[nrchanwav+nrpzm] ;
  modloudmin = new float[nrchanwav+nrpzm] ;
  zcratemin = new float[nrchanwav+nrpzm] ;
   
  CListOfObj ModLoudList ;
  CListOfObj SumLoudList ;
  //  CListOfObj ZCRateList ;
  
  // initialize flags for detecting change between speech and nonspeech and variables to detect min energy!
  for( i=0 ; i<nrchanwav+nrpzm ; i++ ) {
    energymin[i] = 1.0e30 ;
    sumloudmax[i] = 1.0e30 ;
    sumloudmin[i] = 1.0e30 ;
    modloudmax[i] = 1.0e30 ;
    modloudmin[i] = 1.0e30 ;
    zcratemin[i] = 1.0e30 ;
    
    energymintmp[i] = -1.0e30 ;
    zcratemintmp[i] = -1.0e30 ;
    modloudmintmp[i] = -1.0e30 ;
    sumloudmintmp[i] = -1.0e30 ;
    modloudmaxtmp[i] = 0.0 ; // for 'slowly' following the max modloud
    sumloudmaxtmp[i] = 0.0 ; // for 'slowly' following the max sumloud
    modloudmaxspurt[i] = 0.0 ; // min max found on spurts processed so far
    sumloudmaxspurt[i] = 0.0 ; // min max found on spurts processed so far
  } ;
  
#ifdef TESTLEVEL
  fprintf( stderr, "Determine minima and maxima of special features ...\n" ) ;
#endif
  
  usedframes = MAXFRAMESFORMAXDET ;
  // determine speech min resp max of special features (for offline normalization to get features for spdet)
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    frame = 0 ;
    running = 1 ;
    
    // reset sortlists!
    if( !ModLoudList.isEmpty() )
      ModLoudList.removeAll() ;
    if( !SumLoudList.isEmpty() )
      SumLoudList.removeAll() ;
    
    while( running ) {
      // check if any of the sigfiles faces EOF yet
      if( (prefp[chan] = AkuPre[chan]->getNextPre()) == 0 ) {
	running = 0 ;
	break ;
      } ;
      
      if( normchanperc != 0.0 ) {
	
	CFloatObj* modloud = new CFloatObj(prefp[chan]->ModLoud) ;
	CFloatObj* sumloud = new CFloatObj(prefp[chan]->SumLoud) ;
	
	ModLoudList+=( (CObj*)modloud ) ;
	SumLoudList+=( (CObj*)sumloud ) ;
      } ;
        
      // check if at beg, within or at end of Run for detecting Min Energy:
      atbeg = 0 ;
      atend = 0 ;
      nrrun = 0 ;
      inrun = 0 ;
      for( i=0 ; i<MinMaxNrRuns ; i++ ) {
	if( frame==RunStart[i] ) {
	  atbeg = 1 ;
	  nrrun = i ;
	  break ;
	} else if( frame == RunEnd[i] ) {
	  atend = 1 ;
	  nrrun = i ;
	  break ;
	} else if( frame >RunStart[i] && frame<RunEnd[i] ) {
	  inrun = 1 ;
	  nrrun = i ;
	  break ;
	} 
      }
      if( atend ) {
	// next spurt processed
	if( energymin[chan] > energymintmp[chan] )
	  energymintmp[chan] = energymin[chan] ;
	if( zcratemin[chan] > zcratemintmp[chan] )
	  zcratemintmp[chan] = zcratemin[chan] ;
	if( modloudmin[chan] > modloudmintmp[chan] )
	  modloudmintmp[chan] = modloudmin[chan] ;
	if( sumloudmin[chan] > sumloudmintmp[chan] )
	  sumloudmintmp[chan] = sumloudmin[chan] ;
      } else if( atbeg ) {
	// reset min
	energymin[chan] = 1.0e30 ;
	zcratemin[chan] = 1.0e30 ;
	modloudmin[chan] = 1.0e30 ;
	sumloudmin[chan] = 1.0e30 ; 
      } else if( inrun ) {
	// within 
	if( (prefp[chan]->TotalEnergy < energymin[chan]) )
	  energymin[chan] =  prefp[chan]->TotalEnergy ;
	if( prefp[chan]->ZCRate < zcratemin[chan] )
	  zcratemin[chan] = prefp[chan]->ZCRate ;
	if( prefp[chan]->ModLoud < modloudmin[chan] )
	  modloudmin[chan] = prefp[chan]->ModLoud ;
	if( prefp[chan]->SumLoud < sumloudmin[chan] )
	  sumloudmin[chan] = prefp[chan]->SumLoud ;
      }
      
      if( frame % SPURTLENFORMAXDET == 0 && frame != 0) {
	//fprintf( stderr, "Spurt end at frame %d, maxima of channel %d: %f, %f\n", frame, chan, sumloudmaxspurt[chan], modloudmaxspurt[chan]  ) ;
	// look if current max is lower than max found before
	if( sumloudmaxspurt[chan] < sumloudmax[chan] )
	  sumloudmax[chan] = sumloudmaxspurt[chan] ;
	sumloudmaxspurt[chan] = 0.0 ;
	// look if current max is lower than max found before
	if( modloudmaxspurt[chan] < modloudmax[chan] )
	  modloudmax[chan] = modloudmaxspurt[chan] ;
	modloudmaxspurt[chan] = 0.0 ;
      } else if( frame > SKIPLEN ) {
	// use 'unsmoothed' values for finding max!
	if( prefp[chan]->SumLoud > sumloudmaxspurt[chan] )
	  sumloudmaxspurt[chan] = prefp[chan]->SumLoud ;
	if( prefp[chan]->ModLoud > modloudmaxspurt[chan] )
	  modloudmaxspurt[chan] = prefp[chan]->ModLoud ;
      }
      
      if( ++frame > MAXFRAMESFORMAXDET )
	break ;
      
    } ;
    
    // are files shorter then spurtlen used for max detection
    if( frame <= SPURTLENFORMAXDET ) {
       sumloudmax[chan] = sumloudmaxspurt[chan] ;
       modloudmax[chan] = modloudmaxspurt[chan] ;
    } 

    energymin[chan] = energymintmp[chan] ;
    zcratemin[chan] = zcratemintmp[chan] ;
    modloudmin[chan] = modloudmintmp[chan] ;
    sumloudmin[chan] = sumloudmintmp[chan] ;
    
    
    // memorize length of shortest wavfile
    if( frame < usedframes )
      usedframes = frame ;
    
    // overwrite max-values with percentiles, if requested
    CListIterator modloudit ;
    CListIterator sumloudit;
    if( normchanperc != 0.0 ) {
      ModLoudList.quickSort() ;
      SumLoudList.quickSort() ;
      modloudit = ModLoudList.tail() ;
      sumloudit = SumLoudList.tail() ; 
      for( i=0 ; i<(int)(usedframes*normchanperc/100) ; i++ ) {
	--modloudit ;
	--sumloudit ;
      }
     
      sumloudmax[chan] = ((CFloatObj*)(*sumloudit))->getData() ; 
      modloudmax[chan] = ((CFloatObj*)(*modloudit))->getData() ; 
      
      ModLoudList.removeAll() ;
      SumLoudList.removeAll() ;
    } ;
  } ;
    
  // process PZM files
  for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
    
    for( frame=0 ; frame<usedframes ; frame++ ) {
      
      prefppzmfile[pzm] = AkuPrePZMFile[pzm]->getNextPre() ;
      if( prefppzmfile[pzm] == 0 )
	break ;

      // check if at beg, within or at end of Run for detecting Min Energy:
      atbeg = 0 ;
      atend = 0 ;
      nrrun = 0 ;
      inrun = 0 ;
      for( i=0 ; i<MinMaxNrRuns ; i++ ) {
	if( frame==RunStart[i] ) {
	  atbeg = 1 ;
	  nrrun = i ;
	  break ;
	} else if( frame == RunEnd[i] ) {
	  atend = 1 ;
	  nrrun = i ;
	  break ;
	} else if( frame >RunStart[i] && frame<RunEnd[i] ) {
	  inrun = 1 ;
	  nrrun = i ;
	  break ;
	} 
      }
      if( atend ) {
	// next minute processed
	if( energymin[nrchanwav+pzm] > energymintmp[nrchanwav+pzm] )
	  energymintmp[nrchanwav+pzm] = energymin[nrchanwav+pzm] ;
	if( zcratemin[nrchanwav+pzm] > zcratemintmp[nrchanwav+pzm] )
	  zcratemintmp[nrchanwav+pzm] = zcratemin[nrchanwav+pzm] ;
	if( modloudmin[nrchanwav+pzm] > modloudmintmp[nrchanwav+pzm] )
	  modloudmintmp[nrchanwav+pzm] = modloudmin[nrchanwav+pzm] ;
	if( sumloudmin[nrchanwav+pzm] > sumloudmintmp[nrchanwav+pzm] )
	  sumloudmintmp[nrchanwav+pzm] = sumloudmin[nrchanwav+pzm] ;  
      } else if( atbeg ) {
	// reset min
	energymin[nrchanwav+pzm] = 1.0e30 ;
	zcratemin[nrchanwav+pzm] = 1.0e30 ;
	modloudmin[nrchanwav+pzm] = 1.0e30 ;
	sumloudmin[nrchanwav+pzm] = 1.0e30 ;
      } else if( inrun ) {
	if( (prefppzmfile[pzm]->TotalEnergy < energymin[nrchanwav+pzm]) )
	  energymin[nrchanwav+pzm] =  prefppzmfile[pzm]->TotalEnergy ;
	if( prefppzmfile[pzm]->ZCRate < zcratemin[nrchanwav+pzm] )
	  zcratemin[nrchanwav+pzm] = prefppzmfile[pzm]->ZCRate ;
	if( prefppzmfile[pzm]->ModLoud < modloudmin[nrchanwav+pzm] )
	  modloudmin[nrchanwav+pzm] = prefppzmfile[pzm]->ModLoud ;
	if( prefppzmfile[pzm]->SumLoud < sumloudmin[nrchanwav+pzm] )
	  sumloudmin[nrchanwav+pzm] = prefppzmfile[pzm]->SumLoud ;
      }

      if( frame % SPURTLENFORMAXDET == 0 && frame != 0 ) {
	// look if current max is lower than max found before
	if( sumloudmaxtmp[nrchanwav+pzm] < sumloudmax[nrchanwav+pzm] )
	  sumloudmax[nrchanwav+pzm] = sumloudmaxtmp[nrchanwav+pzm] ;
	sumloudmaxtmp[nrchanwav+pzm] = 0.0 ;
	// look if current max is lower than max found before
	if( modloudmaxtmp[nrchanwav+pzm] < modloudmax[nrchanwav+pzm] )
	  modloudmax[nrchanwav+pzm] = modloudmaxtmp[nrchanwav+pzm] ;
	modloudmaxtmp[nrchanwav+pzm] = 0.0 ;
      } else if( frame > SKIPLEN ) {
	if( prefppzmfile[pzm]->SumLoud > sumloudmaxtmp[nrchanwav+pzm] )
	  sumloudmaxtmp[nrchanwav+pzm] = prefppzmfile[pzm]->SumLoud ;
	if( prefppzmfile[pzm]->ModLoud > modloudmaxtmp[nrchanwav+pzm] )
	  modloudmaxtmp[nrchanwav+pzm] = prefppzmfile[pzm]->ModLoud ;
      }
    } ;
    
    if( usedframes <= SPURTLENFORMAXDET ) {
      sumloudmax[nrchanwav+pzm] = sumloudmaxspurt[nrchanwav+pzm] ;
      modloudmax[nrchanwav+pzm] = modloudmaxspurt[nrchanwav+pzm] ; 
    } ;

    energymin[nrchanwav+pzm] = energymintmp[nrchanwav+pzm] ;
    zcratemin[nrchanwav+pzm] = zcratemintmp[nrchanwav+pzm] ;
    modloudmin[nrchanwav+pzm] = modloudmintmp[nrchanwav+pzm] ;
    sumloudmin[nrchanwav+pzm] = sumloudmintmp[nrchanwav+pzm] ;
  } ;
  
#ifdef TESTLEVEL
  fprintf( stderr, "%d frames used for finding min/max\n", usedframes ) ;
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
  

  // memorize length of mixfile if shorter than the other files
  usedframes = frame ; 
  
  // output of min energies. max sumloud, max modloud, max zcrate: 
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    fprintf( logfp, "channel %d: Min energy: %f\n", chan, energymin[chan] ) ;
    fprintf( logfp, "channel %d: Max sumloud: %f\n", chan, sumloudmax[chan] ) ;
    fprintf( logfp, "channel %d: Min sumloud: %f\n", chan, sumloudmin[chan] ) ;
    fprintf( logfp, "channel %d: Max modloud: %f\n", chan, modloudmax[chan] ) ;
    fprintf( logfp, "channel %d: Min modloud: %f\n", chan, modloudmin[chan] ) ;
    fprintf( logfp, "channel %d: Min zcrate: %f\n", chan, zcratemin[chan] ) ;
  } ;
  
  for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
    fprintf( logfp, "pzmfile %d: Min energy: %f\n", pzm, energymin[nrchanwav+pzm] ) ;
    fprintf( logfp, "pzmfile %d: Max sumloud: %f\n", pzm, sumloudmax[nrchanwav+pzm] ) ;
    fprintf( logfp, "pzmfile %d: Min sumloud: %f\n", pzm, sumloudmin[nrchanwav+pzm] ) ;
    fprintf( logfp, "pzmfile %d: Max modloud: %f\n", pzm, modloudmax[nrchanwav+pzm] ) ;
    fprintf( logfp, "pzmfile %d: Min modloud: %f\n", pzm, modloudmin[nrchanwav+pzm] ) ;
    fprintf( logfp, "pzmfile %d: Min zcrate: %f\n", pzm, zcratemin[nrchanwav+pzm] ) ;
  } ;
 
  fflush( logfp ) ;

  delete[] energymintmp ;
  delete[] zcratemintmp ;
  delete[] modloudmintmp ;
  delete[] sumloudmintmp ;

  delete[] sumloudmaxtmp ;
  delete[] modloudmaxtmp ;
  delete[] sumloudmaxspurt ;
  delete[] modloudmaxspurt ;

  return ;
} ;


int StartSpNonSpAll( char **argument, int uselapelnet, int tmppathindex ) { 
  
  // local variables
  int chan ;
  char tmp[MaxLineLength] ;
  char tmp2[MaxLineLength] ;
  char tmp3[MaxLineLength] ;

#ifdef TESTLEVEL
  fprintf( stderr, "Start SpNonSp of all %d channels ... \n", nrchanwav ) ;
#endif

  for( chan=0 ; chan<nrchanwav ; chan++) {
#ifdef TESTLEVEL
    fprintf( stderr, "... %d\n", chan  ) ;
#endif    // start SpNonSp
    strcpy( tmp, argument[(chan)+wavfileoffset] ) ;
    sprintf( tmp2, "%s/%s.apost", argument[tmppathindex], tmp ) ;

    if( uselapelnet ) {
      // combine outputs of two nets! (standard and lapel)
      strcpy( tmp, argument[(chan)+wavfileoffset] ) ;
      sprintf( tmp3, "%s/%s.apost-lapel", argument[tmppathindex], tmp ) ;
     
      if( SpNonSp[chan]->start( tmp2, tmp3 ) == _ERR_ ) {
	fprintf( stderr, "Can't open %d-th  pfile '%s'\n", chan, tmp3 ) ;
	return(-1) ;
      } ;
      // dummy: different pfile should be used here!
      if( SpNonSp2[chan]->start( tmp2, tmp3 ) == _ERR_ ) {
	fprintf( stderr, "Can't open %d-th  pfile '%s'\n", chan, tmp3 ) ;
	return(-1) ;
      } ;    
    } else {
      
      // use only one net output
      if( SpNonSp[chan]->start( tmp2 ) == _ERR_ ) {
	fprintf( stderr, "Can't open %d-th  pfile '%s'\n", chan, tmp2 ) ;
	return(-1) ;
      } ;
      // dummy: different pfile should be used here!
      if( SpNonSp2[chan]->start( tmp2 ) == _ERR_ ) {
	fprintf( stderr, "Can't open %d-th  pfile '%s'\n", chan, tmp2 ) ;
	return(-1) ;
      } ;
    }
    
  } ;
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
 
  return(_OK_) ;
} ;



void CalcEntropy( char **argument, int uselapelnet, int tmppathindex) {

  int i, frame, chan ;
  float prob;

  Entropy_close = new float[nrchanwav] ;
  Chisto histo_close( 0.0, 1.0, 100 ) ;

  Chisto histo_lapel( 0.0, 1.0, 100 ) ;
  if( uselapelnet ) {
    Entropy_lapel = new float[nrchanwav] ;
  } 

  for( chan=0 ; chan< nrchanwav ; chan++ ) {

    Entropy_close[chan] = 0.0 ;
    histo_close.reset_counters() ;
    if( uselapelnet ) {
      Entropy_lapel[chan] = 0.0 ;
      histo_lapel.reset_counters() ;
    }
    //#ifdef TEST_ENTROPY
    //fprintf( stderr, "posteriors: closenet and lapelnet\n") ;
    //#endif

    for( frame=0; frame<nrframe ; frame++ ) {
      
      SpNonSp[chan]->detect();
      histo_close.update((double)(SpNonSp[chan]->getApostSi())) ;
      //#ifdef TEST_ENTROPY
      //fprintf( stderr, "[%d] %f\t%f\n", frame, SpNonSp[chan]->getApostSi(), SpNonSp[chan]->getApostSi2()) ;
      //#endif
      if( uselapelnet ) {
	histo_lapel.update((double)(SpNonSp[chan]->getApostSi2())) ;
      }
    }

    histo_close.convert_counters() ;
    if( uselapelnet ) {
      histo_lapel.convert_counters() ;
    }
    for( i=0 ; i<histo_close.get_number_of_intervalls() ; i++ ) {

      prob = (float)histo_close.get_value(i) ;
      if( prob != 0.0 )
	Entropy_close[chan] += prob * log(prob) ;

      if( uselapelnet ) {
	prob = (float)histo_lapel.get_value(i) ;
	if( prob != 0.0 ) 
	  Entropy_lapel[chan] += prob * log(prob) ;
      }
    }

#ifdef TEST_ENTROPY
    char histoname[MaxLineLength];
    sprintf( histoname, "/n/basil/scratch/tpfau/closehisto%d", chan ) ;
    histo_close.write( histoname ) ;

    fprintf( stderr, "chan %d: Entropy (close mike): %f\n", chan, Entropy_close[chan] ) ;
    if( uselapelnet ) {
      fprintf( stderr, "chan %d: Entropy (lapel mike): %f\n", chan, Entropy_lapel[chan] ) ;
      sprintf( histoname, "/n/basil/scratch/tpfau/lapelhisto%d", chan ) ;
      histo_lapel.write( histoname ) ;
    }
#endif

  } ;

  StartSpNonSpAll( argument, uselapelnet, tmppathindex ) ;

}



void InitAkuPreAndSpNonSp( char **argument, int usemltimeszcr, int usepzmenergy, int crosscorrelwinlen ) { 

  // local variables
  int i ;

#ifdef TESTLEVEL
  fprintf( stderr, "Initializing AkuPre and SpNonSp of all %d channels ... \n", nrchanwav ) ;
#endif

  // construct Preprocessing
  Tool = new CTool( chanfp );
  AkuPre = new CAkuPreSimple*[nrchanwav] ;
  AkuPrePZMFile = new CAkuPreSimple*[nrpzm] ;
  for( i=0 ; i<nrpzm ; i++ )
    AkuPrePZMFile[i] = new CAkuPreSimple( chanfp ) ;

  // sigwinbuffer for correlations!
  SigWin = new CSigWinBuffer*[nrchanwav+nrpzm] ;
  
  // construct SpNonSp
  SpNonSp = new CSpeechNonSpeechANN*[nrchanwav] ;
  SpNonSp2 = new CSpeechNonSpeechANN*[nrchanwav] ;

  // init channel specific akupre and spnonsp
  for( i=0 ; i<nrchanwav; i++ ) {
    AkuPre[i] = new CAkuPreSimple( chanfp ) ;
    //SpNonSp[i] = new CSpeechNonSpeech( PRESPECLEN+4, (double)WINDOW_DELTA/(double)SAMPLE_FRQ , spnonspchancfgfp ) ; // Achtung hard coded length of feature file
    // use 26dim feature vec
    SpNonSp[i] = new CSpeechNonSpeechANN( (double)WINDOW_DELTA/(double)SAMPLE_FRQ , spnonspchancfgfp ) ;
    //SpNonSp2[i] = new CSpeechNonSpeech( PRESPECLEN+4, (double)WINDOW_DELTA/(double)SAMPLE_FRQ , spnonspchancfgfp2 ) ; 
    SpNonSp2[i] = new CSpeechNonSpeechANN( (double)WINDOW_DELTA/(double)SAMPLE_FRQ , spnonspchancfgfp2 ) ; 
    
  } ;

  for( i=0 ; i<nrchanwav+nrpzm; i++ ) 
    // initialize sigwinbuffers
    SigWin[i] = new CSigWinBuffer( WINDOW_DELTA, crosscorrelwinlen, "FileNIST", AkuPre[0]->getSampleShift(), AkuPre[0]->getPreemphase() ) ;
  
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
} ;



int StartAkuPreAll( char **argument ) { 
  
  // local variables
  int chan ;

#ifdef TESTLEVEL
  fprintf( stderr, "Start AkuPre of all %d channels ... \n", nrchanwav ) ;
#endif

  for( chan=0 ; chan<nrchanwav ; chan++) {
#ifdef TESTLEVEL
    fprintf( stderr, "... %d\n", chan  ) ;
#endif    // start AkuPre
    if( AkuPre[chan]->startAkuPre( argument[(chan)+wavfileoffset], ByteSkip[chan] ) == _ERR_ ) {
      fprintf( stderr, "Can't open %d-th  sigfile '%s'\n", chan, argument[(chan)+wavfileoffset] ) ;
      return(-1) ;
    } ;
  } ;
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif
 
#ifdef TESTLEVEL
  fprintf( stderr, "Start AkuPre of all %d PZMfiles ...\n", nrpzm ) ;
  fprintf( stderr, "Start SigWinBuffer of all %d PZMfiles ... \n", nrpzm ) ;
#endif
  for( int i=0 ; i<nrpzm ; i++ ) {
    if( AkuPrePZMFile[i]->startAkuPre( argument[pzmfileindex+i], ByteSkipPZM[i] ) == _ERR_ ) {
      fprintf( stderr, "Can't open pzmfile '%s'\n", argument[pzmfileindex+i] ) ;
      return(-1) ;
    } ;
    // start sigwinbuffer for pzmfiles to calc correlations
    SigWin[nrchanwav+i]->startBuf( argument[pzmfileindex+i], ByteSkipPZM[i] ) ;
  } ;
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif

  // start sigwinbuffer to calculate correlations!
#ifdef TESTLEVEL
  fprintf( stderr, "Start SigWinBuffer of all %d channels ... \n", nrchanwav ) ;
#endif
  for( chan=0 ; chan<nrchanwav ; chan++) {
#ifdef TESTLEVEL
    fprintf( stderr, "... %d\n", chan  ) ;
#endif    // start AkuPre
    if( SigWin[chan]->startBuf( argument[(chan)+wavfileoffset], ByteSkip[chan] ) ) ;
  } ;
#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif

  return(_OK_) ;

} ;




float CalcCrossCorrelation( float *window1, float *window2, int winlen, int range, int &shiftindex ) {

  float crosscorrel = 0.0 ;
  float autocorrel1 = 0.0 ;
  float autocorrel2 = 0.0 ;

  float crosscorrelmax = -1.0 ;
  int shiftindexformax ;

  for( int shift=-range ; shift<range ; shift++ ) {
    
    crosscorrel = 0.0 ;
    autocorrel1 = 0.0 ;
    autocorrel2 = 0.0 ;

    for( int i=range ; i<(winlen)-range ; i++ ) {
      crosscorrel += window1[i]*window2[i-shift] ;
      autocorrel1 += window1[i]*window1[i] ;
      autocorrel2 += window2[i-shift]*window2[i-shift] ;
    } ;
    
    crosscorrel /= sqrt( autocorrel1*autocorrel2) ;
    crosscorrel = abs( crosscorrel );

    if( crosscorrel > crosscorrelmax ) {
      crosscorrelmax = crosscorrel ;
      shiftindexformax = shift ;
    }
  }

  shiftindex = shiftindexformax;

  return( crosscorrelmax ) ; 
} ;




int GetCorrelationsOnOverlapsAndSpeech( int &framesused, int crosscorrelwinlen=WINDOW_LENGTH*3, int crosscorrelshift=100) {

#ifdef TESTLEVEL
  fprintf( stderr, "Calculate crosscorrelation between indiv. channels (only for overlaps) ...\n" ) ;
  fprintf( stderr, "Calculate crosscorrelation between indiv. channels and pzm signals (only for speech segments) ...\n" ) ;
#endif


  int i, j, n, k, pzm, nrcomb=0,frame, nrpzmcorrel, frameshift ;
  float auto1, auto2 ;
  

  for( i=1 ; i<nrchanwav ; i++ ) 
    nrcomb += i ;

  // calc correlation from each channel to the pzmfiles
  nrpzmcorrel = nrchanwav*nrpzm ;

  Correl = new float*[nrframe] ;
  CorrelPZM = new float*[nrframe] ;


  float **win = new float*[nrchanwav+nrpzm] ; // one window for each channel plus one window for each pzm channel
  for( i=0 ; i<nrchanwav+nrpzm ; i++ )
    win[i] = new float[crosscorrelwinlen] ;

  // calculate for which frame the crosscorrel is calculated:
  //frameshift = (int)(((float)crosscorrelshift / (float)WINDOW_DELTA)+0.5) ;
  frameshift = (int)(((float)((crosscorrelwinlen/2)-(WINDOW_DELTA/2)) / (float)WINDOW_DELTA)+0.5) ;

  // allocate memory for correlations
  for( frame=0 ; frame<nrframe ; frame++ ) {
    Correl[frame] = new float[nrcomb];
    CorrelPZM[frame] = new float[nrchanwav*nrpzm] ;
  } ; 
  
  // set correlations of first frameshift frames to zero (can't be calculated in the way used here!)
  n=0 ;
  k=0 ;
  for( frame=0 ; frame <frameshift ; frame++ ) {
    for( i=0 ; i<nrchanwav ; i++ ) {
      for( j=i+1 ; j<nrchanwav ; j++ ) {
	Correl[frame][n] = 0.0 ;
	n++ ; 
      } ;
      for( j=0 ; j<nrpzm ; j++ ) {
	CorrelPZM[frame][k] = 0.0 ;
	k++ ;
      } ;
    } ;
  }


  // loop over all frames to calculate correlations between all channels
  for( frame=0 ; frame<nrframe-frameshift ; frame++ ) {
    // allocate memory to store correlations of each frame 
  
    // get signal of current frame
    for( i=0 ; i<nrchanwav+nrpzm ; i++ )
      if( SigWin[i]->getWin( win[i] ) != _OK_ ) {
	framesused = frame ;
	return( _ERR_ ) ;
      } ;

    // calculate correlations between channels
    n=0 ;
    k=0 ;
    int maxshift;
    for( i=0 ; i<nrchanwav ; i++ ) {
      // correlations between channels
      for( j=i+1 ; j<nrchanwav ; j++ ) {
	//if( OverlapFlag[frame+frameshift][i] == 1 && OverlapFlag[frame+frameshift][j] == 1 )
	if( SpeechFlag[frame+frameshift][i] >= PUS && SpeechFlag[frame+frameshift][j] >= PUS )
	  Correl[frame+frameshift][n] = CalcCrossCorrelation( win[i], win[j], crosscorrelwinlen, crosscorrelshift, maxshift ) ;
	else 
	  Correl[frame+frameshift][n] = 0.0 ;
	n++ ;
      } 
      // correlations with PZM signals
      for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
	//if( OverlapFlag[frame+frameshift][i] == 1 )
	if( SpeechFlag[frame+frameshift][i] >= PUS )
	  CorrelPZM[frame+frameshift][k] = CalcCrossCorrelation( win[i], win[nrchanwav+pzm], crosscorrelwinlen, crosscorrelshift, maxshift ) ;
	else
	  CorrelPZM[frame+frameshift][k] = 0.0 ;
#ifdef LOG_CORREL
	fprintf( logfp, "[%d]\tchan: %d\tpzm: %d\tcorrel: %f\tshift: %d\n", frame+frameshift, i, pzm, CorrelPZM[frame+frameshift][k], maxshift ) ;
#endif
	k++ ;
      } ;
    } ;
  } ;

  for( i=0 ; i<nrchanwav+nrpzm ; i++ )
    delete[] win[i] ;
  delete[] win ;
    

  return(_OK_) ;
} ;

float sigmoid( float min, float max, int length, float slope, int relframe ) {

  if( relframe == 0 ) 
    return(1) ;
  else if( relframe > 0 ) 
    return( (((1/(1+exp(slope/float(length)*(float)relframe)))-0.5)*(1.0-min)/0.5)+1.0 ) ;
  else
    return( (((1/(1+exp(slope/float(length)*(float)relframe)))-0.5)*(max-1.0)/0.5)+1.0 ) ;
}



// this functions adjusts the sensitivity of the S/NS detector for regions in between speech chunks!
// the sensitivity is first linearly increased to a given max (baselinesens/maxfactor) over the first ten
// frames after each speech chunk,
// then a sigmoid function is used to decrease the sensitivity to 'baseline' over the next tauforward frames
// it'll be further decreased to a minimum with the same slop 
// T.P. 01/31/2002
int SetSensitivity( float maxfactor, float minfactor, int tauforward, int taubackward, float slope, int chan ) {

  static float prior_merker = SpNonSp2[0]->getSpPrior() ;

fprintf( stderr, "priormerker: %f\n", prior_merker ) ;


  int increasetime = 10 ;
  int last = -1, frame ;
  int f, dist_to_last ;
  float baselinesens_sp = prior_merker ;
  float minsens_sp = prior_merker/minfactor;
  if( minsens_sp > 1.0 )
    minsens_sp = 0.99 ;
  float tmp ;

  //Sens = new float*[nrchanwav] ;
  //Sens[chan] = new float[nrframe] ;

  //Sens[chan][0] = baselinesens_sp ;      
  //Sens[chan][0] = minsens_sp ;      

  // reset array:
  for( frame=0 ; frame<nrframe ; frame++ )
    Sens[chan][frame] = minsens_sp ;

  // forward loop, set slope after each speech region (
  f=0;
  // search for end of first speech region:
  while( SpeechFlag[f][chan] == P && f<nrframe ) {
    //Sens[chan][f] = baselinesens_sp ;      
    Sens[chan][f] = minsens_sp ;      
    f++ ;
    if( f == nrframe )
      break ;
  }
  
  if( f<nrframe) {
    while( SpeechFlag[f][chan] == S && f<nrframe) {
      //Sens[chan][f] = baselinesens_sp ;      
      Sens[chan][f] = minsens_sp ;      
      f++ ;
      if( f == nrframe )
	break ;
    }
  } 
  
  last = f-1 ;
  
  // do loop over rest of frames
  for( frame=f ; frame<nrframe ; frame++ ) {
    // default value:
    //Sens[chan][frame] = baselinesens_sp ;      
    Sens[chan][frame] = minsens_sp ;      
    
    if( SpeechFlag[frame][chan] == P ) {
      // current frame is a nonspeech frame: adjust sensitivity according to distance from last speech region!
      dist_to_last = frame-last ;
      if( dist_to_last <= increasetime ) {
	// increase sensitivity linearly to max:
	Sens[chan][frame] = baselinesens_sp / ( dist_to_last * (maxfactor-1.0 )/10.0 + 1.0 ) ;
      } else {
	// use sigmoid:
	Sens[chan][frame] = baselinesens_sp / ( sigmoid( minfactor, maxfactor, tauforward, slope, (dist_to_last - increasetime - tauforward*100) ) ) ;
      }
    } else {
      last = frame ;
    } ;
    
  } // end forward loop
  
#ifdef TEST_SENS
  fprintf( stderr, "Sensitivity after forward pass!\n" ) ;
  for( frame=0 ; frame<nrframe ; frame++ ) {
    fprintf( stderr, "[%d] ch%d:  %f (Sens),  %d (S/NS))\n", frame, chan, Sens[chan][frame], SpeechFlag[frame][chan] ) ;
  }
#endif
  
  
  // backward loop, set slope before each speech region (
  f=nrframe-1;
  // search for end of first speech region:
  while( SpeechFlag[f][chan] == P && f >=0 ) {
    //Sens[chan][f] = baselinesens_sp ;    
    f-- ;
    if( f == -1 )
      break ;
  }
  if( f != -1) {
    while( SpeechFlag[f][chan] == S && f >=0 ) {
      //Sens[chan][f] = baselinesens_sp ;      
      f-- ;
      if( f == -1 )
	break ;
    }
  } 
  
  last = f+1 ;
  
  // do loop over rest of frames
  for( frame=f ; frame>=0 ; frame-- ) {
    // default value:
    //Sens[chan][frame] = baselinesens_sp ;      
    //Sens[chan][frame] = baselinesens_sp ;      
    
    if( SpeechFlag[frame][chan] == P ) {
      // current frame is a nonspeech frame: adjust sensitivity according to distance from last speech region!
      dist_to_last = last-frame ;
      
      if( dist_to_last <= increasetime ) {
	// increase sensitivity linearly to max:  (only if sensitivity will be increased (prior decreases)
	if( (tmp = baselinesens_sp / ( dist_to_last * (maxfactor-1.0 )/10.0 + 1.0 ) ) < Sens[chan][frame] )
	  Sens[chan][frame] = tmp ;
      } else {
	// use sigmoid: (only if sensitivity will be increased (prior decreases)
	if( (tmp=baselinesens_sp / ( sigmoid( minfactor, maxfactor, taubackward, slope, (dist_to_last-increasetime-tauforward*100)))) < Sens[chan][frame] )
	  Sens[chan][frame] = tmp ;
      }
    } else {
      last = frame ;
    } ;
  } // end backward loop
  
#ifdef TEST_SENS
  fprintf( stderr, "Sensitivity after backward pass!\n" ) ;
  for( frame=0 ; frame<nrframe ; frame++ ) {
    fprintf( stderr, "[%d] ch%d:  %f (Sens),  %d (S/NS))\n", frame, chan, Sens[chan][frame], SpeechFlag[frame][chan] ) ;
  }
#endif
  
  
  return(1) ;
}


int CalcSpeechFrames( ESpeechFlag **speechflag, int chan ) {

  int frame, count=0 ;
  
  for( frame=0 ; frame<nrframe ; frame++ )
    if( speechflag[frame][chan] >= PUS )
      count++ ;

  return( count ) ;
}



// two pass algorithm:
// first pass: start from end move all undef 'after' S to 'S'
// second pass: start from beg: move all undef to state of last valid decision !
void ProcessUndef( ESpeechFlag** speechflag, int chan ) {

  int frame ;
  //ESpeechFlag last = speechflag[nrframe-1][chan] ;
  ESpeechFlag last = P ;

  for( frame=nrframe-2 ; frame>=0 ; frame-- ) {
    if( speechflag[frame][chan] == U ) {
      if( last == S )
	speechflag[frame][chan] = last ;
    } else
      last = speechflag[frame][chan] ;
  }
  
  last = P ;
  for( frame=1 ; frame<nrframe ; frame++ ) {
    if( speechflag[frame][chan] == U )
      speechflag[frame][chan] = last ;
    else
      last = speechflag[frame][chan] ;
    
  }

}




// look into 'nonspeech' regions of firts pass and try to find backchannels!
// use second pass SpNonSp detectors (different parameters and dynamis sensitivity!)
// result is in: SpeechFlag2 array!
int GetSpNonSpSecondPass( float maxsens, float minsens, int forwardtime, int backwardtime, float sigmoidslope, float thres) {

  int chan, frame, f, countspfirst, countspsecond;
  ESpeechFlag last, next ;
  float maxsenstmp, minsenstmp ;
  Sens = new float*[nrchanwav] ;

  // set parameters for changing min and maxsens parameter, if too many speech frame are detected!
  float decreasevalue = 0.9 ;
  float min_minsens = SpNonSp2[0]->getSpPrior() / 0.9 ;
  float min_maxsens = 1.01 ;

  for( chan=0 ; chan<nrchanwav ; chan++ ) {

    minsenstmp = minsens ;
    maxsenstmp = maxsens ;

    Sens[chan] = new float[nrframe] ;

#ifdef TEST_SECPASS
    fprintf( stderr, "set baseline  sensitivity of chan %d\n", chan ) ;
#endif
    // set sensitivity for second pass s/ns
    SetSensitivity( maxsens, minsens, forwardtime, backwardtime, sigmoidslope, chan ) ;

#ifdef TEST_SECPASS
    fprintf( stderr, "start loop\n" );
#endif
    // loop until second pass gives less than x% speech (as percent of total nr of frames!!!):
    int running = 1 ;
    while(running) {

      last = S ;
      for( frame=0 ; frame<nrframe ; frame++ ) {
	
	// resetbefore each loop
	SpeechFlag2[frame][chan] = P ;

	// check for beginning nonspeech regions:
	if( SpeechFlag[frame][chan] == P ) {
	  if( last == S ) {
	    // restart S/NS detector
#ifdef TEST_SECPASS_HIGHLEVEL
	    fprintf( stderr, "chan %d: restart at: %d\n", chan, frame ) ;
#endif
	    SpNonSp2[chan]->restartat( frame ) ;
	    // set Prior:
	    SpNonSp2[chan]->setSpPrior( Sens[chan][frame] ) ;
	    SpNonSp2[chan]->setSiPrior( (1.0-Sens[chan][frame]) ) ;
	    // do detection for current frame
	    SpeechFlag2[frame][chan] =  SpNonSp2[chan]->detect(0) ;
#ifdef TEST_SECPASS_HIGH
	    fprintf( stderr, "chan %d, frame: %d: detect: %d\n", chan, frame, SpeechFlag2[frame][chan] ) ;
#endif
	  } else {
	    // within Nonspeech region:
	    // set Prior:
	    SpNonSp2[chan]->setSpPrior( Sens[chan][frame] ) ;
	    SpNonSp2[chan]->setSiPrior( (1.0-Sens[chan][frame]) ) ;
	    // do detection for current frame
	    SpeechFlag2[frame][chan] =  SpNonSp2[chan]->detect(0) ;
#ifdef TEST_SECPASS_HIGH
	    fprintf( stderr, "chan %d, frame: %d: detect: %d\n", chan, frame, SpeechFlag2[frame][chan] ) ;
#endif
	  }
	} else {
	  // speech region: do nothing:
	  // SpeechFlag2[frame][chan] = S ;
	  ;
	}
	
	last = SpeechFlag[frame][chan] ;
      } // for frame


      countspsecond = CalcSpeechFrames( SpeechFlag2, chan ) ;
      countspfirst =  CalcSpeechFrames( SpeechFlag, chan ) ;

#ifdef TEST_SECPASS
      fprintf( stderr, "before undef processing:\n nrspeech first: %d\n nrspeech second: %d\n", countspfirst, countspsecond ) ;
#endif
      
      ProcessUndef( SpeechFlag2, chan ) ;

      countspsecond = CalcSpeechFrames( SpeechFlag2, chan ) ;
      countspfirst =  CalcSpeechFrames( SpeechFlag, chan ) ;
 
#ifdef TEST_SECPASS
      fprintf( stderr, "after undef processing:\n nrspeech first: %d\n nrspeech second: %d\n", countspfirst, countspsecond ) ;
#endif

      // check if too much speech os detected:
      if( (float)countspsecond/(float)nrframe < thres  ) {
	// exit loop
	// SetSensitivity( maxsens, minsens, forwardtime, backwardtime, sigmoidslope, chan ) ;
	running = 0 ;
	//break ;
      } else {
	// check if minimum sensitivities are reached
	if( (maxsenstmp <= (min_maxsens+0.001)) && (minsenstmp <= (min_minsens+0.001)) ) {
	  //for( frame=0 ; frame<nrframe ; frame++ ) 
	    // don't use second pass then
	  //SpeechFlag2[frame][chan] = P ;
	  running = 0 ;
#ifdef TEST_SECPASS
	  fprintf( stderr, "min sensitivity (%f, %f) reached\n", maxsenstmp, minsenstmp ) ;
#endif
	  //break ;
	} else { 
	  // reduce maxsens and minsens by factor
	  if( (maxsenstmp*decreasevalue) > min_maxsens )
	    maxsenstmp *= decreasevalue ;
	  else
	    maxsenstmp = min_maxsens ;
	  if( (minsenstmp*decreasevalue) > min_minsens )
	    minsenstmp *= decreasevalue ;
	  else
	    minsenstmp = min_minsens ;

#ifdef TEST_SECPASS
	  fprintf( stderr, "chan %d: set sensitivities to %f and %f\n", chan, maxsenstmp, minsenstmp ) ;
#endif
	  SetSensitivity( maxsenstmp, minsenstmp, forwardtime, backwardtime, sigmoidslope, chan ) ;
	}

#ifdef TESTSECPASS_LOW
	fprintf( stderr, "chan %d: too many speech frames (%f percent) detected: set sensitivity: max %f, min %f\n", chan, (float)countspsecond/(float)nrframe, maxsenstmp, minsenstmp ) ;
#endif	
       
      }
	
    } // while
     
  } // for chan
 
  return(1) ;
}


void ReviseSecondPassOutput( int maxspeechlen ) {

  int chan, frame, spurtlen, f ;

  for( chan=0; chan<nrchanwav ; chan++ ) {

    if( SpeechFlag2[0][chan] >= PUS )
      spurtlen = 1 ;
    else
      spurtlen = 0 ;

    for( frame=1 ; frame<nrframe ; frame++ ) {

      if( SpeechFlag2[frame][chan] >= PUS ) {
	if( SpeechFlag2[frame-1][chan] < PUS ) {
	  // beginning of spurt:
	  spurtlen = 1 ;
	} else {
	  // within spurt
	  spurtlen++ ;
	} // end else
      } else if( SpeechFlag2[frame-1][chan] >= PUS ) {
	// end of spurt
	if( spurtlen > maxspeechlen ) {
	  // do not believe in this decision, 
	  // since that long a spurt should have already  been found in the first pass:
	  // so discard it:
	  for( f=frame-1 ; f>=frame-spurtlen ; f-- )
	    SpeechFlag2[f][chan] = P ;
fprintf( stderr, "[%d]: chan %d: remove speech region of length %d\n", frame, chan, spurtlen ) ;

	} // end if
      } // end else


    } // end for frame

    // process last frame:
    if( SpeechFlag2[nrframe-1][chan] >= PUS ) {
      // end of last spurt:
      spurtlen++ ;
      if( spurtlen > maxspeechlen ) {
	// do not believe in this decision, 
	// since that long a spurt should have already  been found in the first pass:
	// so discard it:
	for( f=nrframe-1 ; f>=nrframe-spurtlen ; f-- )
	  SpeechFlag2[f][chan] = P ;
      } // end if
    } // end if last frame  

  } // end for chan

}



int GetSpNonSpAndEnergy( char **argument, int normchan=1, int normchansecondpass=0, float normchanperc=0.0, int usepzmenergy=1, int usemodloudtimeszcrate=1, int usemaxnorm=1 ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Normalize features and collect S/NS-info...\n" ) ;
#endif

  // local variables
  int frame, chan, tmpframe, running, count, pzm, i ;
  ESpeechFlag *lastflag = new ESpeechFlag[nrchanwav] ;

  SPreFeature *prefp_nonorm ;
  if( !normchan || !normchansecondpass ) 
    prefp_nonorm = new SPreFeature[nrchanwav] ;
  
  // initialize array to remember status of last identified spnonsp-state per channel
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    lastflag[chan] = P ;
  } ;

#ifdef TESTLEVEL
  fprintf( stderr, "Get SpNonSp-Info and Energy of all channels ...\n" ) ;
#endif

  // prepare to store framewise spnonsp-info in global arrays
  SpeechFlag = new ESpeechFlag*[nrframe] ;
  SpeechFlag2 = new ESpeechFlag*[nrframe] ;  
  SpeechFlagOut = new ESpeechFlag*[nrframe] ;  
  Energy = new float*[nrframe] ;
  //EnergyNoSmooth = new float*[nrframe] ;
  ModLoud = new float*[nrframe] ;
  SumLoud = new float*[nrframe] ;
  for( frame=0 ; frame<nrframe ; frame++ ) { 
    SpeechFlag[frame] = new ESpeechFlag[nrchanwav] ; 
    SpeechFlag2[frame] = new ESpeechFlag[nrchanwav] ;
    SpeechFlagOut[frame] = new ESpeechFlag[nrchanwav] ;
    Energy[frame] = new float[nrchanwav] ;
    //EnergyNoSmooth[frame] = new float[nrchanwav] ;
    ModLoud[frame] = new float[nrchanwav] ;
    SumLoud[frame] = new float[nrchanwav] ;
  }
  // reset acoustic preprocessing for channels
  for( chan=0 ; chan<nrchanwav ; chan++) {
    // clear AkuPre
    AkuPre[chan]->clearAkuPre() ;
    if( AkuPre[chan]->startAkuPre( argument[(chan)+wavfileoffset], ByteSkip[chan] ) == _ERR_ ) {
      fprintf( stderr, "Can't open %d-th  sigfile '%s'\n", chan, argument[(chan)+wavfileoffset] ) ;
      delete[] lastflag ;
      return(_ERR_) ;
    } ;
  } ;

  for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
    AkuPrePZMFile[pzm]->clearAkuPre() ;
    if( AkuPrePZMFile[pzm]->startAkuPre( argument[pzmfileindex+pzm], ByteSkipPZM[pzm] ) == _ERR_ ) {
      fprintf( stderr, "Can't open mixfile '%s'\n", argument[pzmfileindex+pzm] ) ;
      delete[] lastflag ;
      return(_ERR_) ;
    } ;
  } ;

  // do loop over all channels and collect speechnonspeech-info
  for( frame=0 ; frame<nrframe ; frame++ ) {
    // get feature vecs, prepare feature vecs by normalizing
    meanenergy = 0.0 ;
    running = 1 ;
    for( chan=0 ; chan<nrchanwav ; chan++) {
      prefp[chan] = AkuPre[chan]->getNextPre() ;
      if( prefp[chan] == 0 ) {
	nrframe = frame ;
	fprintf( stderr, "Unexpected EOF reached for file '%s' after %d frames\n", argument[(chan)+wavfileoffset], frame ) ;
	running = 0 ; 
	break ;
      } ;
   
      // prepare spnonsp-detection on unnormalized features!
      if( !normchan || !normchansecondpass ) {
	// memorize unnormalized features!
	prefp_nonorm[chan].TotalEnergy = prefp[chan]->TotalEnergy ;
	prefp_nonorm[chan].ZCRate = prefp[chan]->ZCRate ;
	prefp_nonorm[chan].SumLoud = prefp[chan]->SumLoud ;
	prefp_nonorm[chan].ModLoud = prefp[chan]->ModLoud ;
	for( i=0 ; i<PRESPECLEN ; i++ )
	  prefp_nonorm[chan].Spec[i] = prefp[chan]->Spec[i] ;
	if( usemodloudtimeszcrate ) 
	  prefp_nonorm[chan].ModLoudTimesZCRate = ((prefp[chan]->ModLoud-modloudmin[chan])/(modloudmax[chan]-modloudmin[chan])) * (prefp[chan]->ZCRate-zcratemin[chan]) ;
	// attention additional feature (PZMEnergy will be set later if required 
      } ;

      if( usemodloudtimeszcrate ) {
	prefp[chan]->ModLoudTimesZCRate = ((prefp[chan]->ModLoud-modloudmin[chan])/(modloudmax[chan]-modloudmin[chan])) * (prefp[chan]->ZCRate-zcratemin[chan]) ;
      
      }
      if( normchan || normchanperc != 0.0 ) {
	// normalize channel features: (maxarrays either conatin max or percentile of max at this time!!!)
	prefp[chan]->TotalEnergy -= energymin[chan] ;
	if( usemaxnorm ) {
	  prefp[chan]->SumLoud /= sumloudmax[chan] ;
	  //prefp[chan]->ZCRate /= zcratemax[chan] ;    // no normalization of zcrate needed as this is independent of scaling of wavfile
	  prefp[chan]->ModLoud /= modloudmax[chan] ;
	} else { 
	  prefp[chan]->SumLoud /= sumloudmin[chan] ;
	  //prefp[chan]->ZCRate /= zcratemin[chan] ;    // no normalization of zcrate needed as this is independent of scaling of wavfile
	  prefp[chan]->ModLoud /= modloudmin[chan] ;
	} 
      } ; 

      // calc mean energy over all channel energies
      meanenergy += prefp[chan]->TotalEnergy ;
    } ;

    // check if any soundfile met EOF!
    if( running == 0 ) {
      // stop processing soundfiles!
      nrframe = frame ;
      break ;
    } ;

    // get pzmfile-features
    for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
      prefppzmfile[pzm] = AkuPrePZMFile[pzm]->getNextPre() ;
      if( prefppzmfile[pzm] == 0 ) {
	fprintf( stderr, "Unexpected EOF reached for file '%s'\n", argument[pzmfileindex+pzm] ) ;
	nrframe = frame ;
	break ;
      } ;
    }
        
    if( usepzmenergy ) {
      for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
	prefppzmfile[pzm]->TotalEnergy -= energymin[nrchanwav+pzm] ;
	if( usemaxnorm ) {
	  prefppzmfile[pzm]->SumLoud /= sumloudmax[nrchanwav+pzm] ;
	  prefppzmfile[pzm]->ModLoud /= modloudmax[nrchanwav+pzm] ;
	  //prefppzmfile->ZCRate /= zcratemax[nrchanwav+1] ;
	} else {
	  prefppzmfile[pzm]->SumLoud /= sumloudmin[nrchanwav+pzm] ;
	  prefppzmfile[pzm]->ModLoud /= modloudmin[nrchanwav+pzm] ;
	  //prefppzmfile->ZCRate /= zcratemin[nrchanwav+1] ;
	} 
      }    
    } 

    //meanenergyohnemix = (meanenergy/nrchanwav) ;
    //meanenergy += prefpmixfile->TotalEnergy ;
    meanenergy /= (nrchanwav) ;

    // normalize channel energies with mean over channels    
    for( chan=0 ; chan<nrchanwav ; chan++) {
      // two different methods to normalize channel energies!
      //prefp[chan]->TotalEnergy -= meanenergy ;
      //EnergyNoSmooth[frame][chan] = prefp[chan]->TotalEnergy ;
      if( normchan )
	prefp[chan]->TotalEnergy -= meanenergy  ;
      Energy[frame][chan] = prefp[chan]->TotalEnergy ;
      ModLoud[frame][chan] = prefp[chan]->ModLoud ;
      SumLoud[frame][chan] = prefp[chan]->SumLoud ;
    } ;

    // normalize pzmfile energy with mean over channels to normalize feature vectors for channel specific spnonsp
    if( usepzmenergy ) {
      // calc mean over all pzmfiles
      float mean=0.0 ;
      for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
	prefppzmfile[pzm]->TotalEnergy -= meanenergy ;
	mean += prefppzmfile[pzm]->TotalEnergy ;
      } 
      mean /= nrpzm ;
      // now normalize with pzm-mean! (use 25th or 26th component of feature vector
      for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
	for( chan=0 ; chan<nrchanwav ; chan++ ) {
	  //prefp[chan]->ModLoudTimesZCRate = prefp[chan]->TotalEnergy - prefppzmfile->TotalEnergy ;
	  if( usemodloudtimeszcrate ) {
	    // 26dim feature vector
	    prefp[chan]->PZMEnergy = prefp[chan]->TotalEnergy - mean  ;
	    if( !normchan || !normchansecondpass )
	      prefp_nonorm[chan].PZMEnergy = prefp[chan]->TotalEnergy - mean  ;
	  } else {
	    // 25dim feature vector
	    // overwrite special feature ModLoudTimesZCRate with Energydiff between channel and pzm!
	    prefp[chan]->ModLoudTimesZCRate = prefp[chan]->TotalEnergy - mean  ;
	    if( !normchan || !normchansecondpass )
	      prefp_nonorm[chan].ModLoudTimesZCRate = (prefp[chan]->TotalEnergy - mean)  ;
	  }	    
	}
      }
    }

    // do SpNonSp-detection (nonlapelnet)
    for( chan=0 ; chan<nrchanwav ; chan++) {

      // initialize other arrays with 'P'
      SpeechFlag2[frame][chan] = P ;
      SpeechFlagOut[frame][chan] = P ;

      // detect and update (if flag is set in cfg-file!)
      if( normchan ) {
	
	//fprintf( stderr, "chan %d: ", chan ) ;
	// do spnonsp-detection now
	if( (SpeechFlag[frame][chan] = SpNonSp[chan]->detect()) == INVALID ) 
	  nrframe = frame ;   

#ifdef TEST_HIGHLEVEL
	fprintf( stderr, "[chan %d, frame %d]: 1st pass: %d\n", chan, frame, SpeechFlag[frame][chan] ) ;
#endif
      } else {

	//fprintf( stderr, "chan %d: ", chan ) ;
	// do spnonsp-detection now:
	if( (SpeechFlag[frame][chan] = SpNonSp[chan]->detect()) == INVALID ) 
	  nrframe = frame ;

#ifdef TEST_HIGHLEVEL
	fprintf( stderr, "[chan %d, frame %d]: 1st pass: %d\n", chan, frame, SpeechFlag[frame][chan] ) ;
#endif

      } 

  

    } ;

  } ;
  

  // process undef frames:
  for( chan=0 ; chan<nrchanwav ; chan++ )
    ProcessUndef( SpeechFlag, chan ) ;


  delete[] lastflag ;

  if( !normchan || !normchansecondpass )
    delete[] prefp_nonorm ;
  
  return (_OK_) ;

#ifdef TESTLEVEL
  fprintf( stderr, "... DONE\n\n" ) ;
#endif

} ;



int MergeFirstAndSecondPassSpNonSp() {
  int frame, chan ;

  for( chan=0 ; chan<nrchanwav;chan++ ) {

    for( frame=0 ; frame<nrframe ; frame++ ) {

      SpeechFlagOut[frame][chan] = P ;

      if( SpeechFlag[frame][chan] == S ) {
	// copy it over
	SpeechFlagOut[frame][chan] =  SpeechFlag[frame][chan] ;
      } else {
	// overwrite firstpass decision with second pass decision!
	SpeechFlagOut[frame][chan] = SpeechFlag2[frame][chan] ;
      } ;

    } // end for frame

  } // end for chan


#ifdef TEST_MERGE
  fprintf( stderr, "\n\nSpeechFlagOut after merging with SpeechFlag2 ...\n\n" ) ;
  for( frame=0 ; frame<nrframe ; frame++ ) {
    fprintf( stderr, "[%d]: ", frame ) ;

    for( chan=0 ; chan<nrchanwav ; chan++ ) {

      fprintf( stderr, "%d ", SpeechFlagOut[frame][chan] ) ;

    } 
    fprintf( stderr, "\n" ) ;

  }
#endif


  return(1) ;
};





// also look at channel energies to decide on activity, only, if both, the HMM-detector and the energy threshold
// decide for speech: set SpeechFlag to 'S'
int CorrectSpNonSpWithEnergyThres( int nrthres, float *thres ) {
  
#ifdef TESTLEVEL
  fprintf( stderr, "Use energy threshold to correct S/NS info\n"  ) ;
#endif


  // local variables
  int chan, frame ;

  if( (nrthres != 0) && (nrthres!=nrchanwav) ) {
    // either one global threshold for all channels or indiv thresholds for ALL channels
    fprintf( stderr, "Sorry, can not perform comparison with energy threshold!\n" ) ;
    fprintf( stderr, "You must either use one global threshold or one threshold for each channel!\n" ) ;
    return(_ERR_) ;
  } ;
    
  for( frame=0 ; frame<nrframe ; frame++ ) {
    for( chan=0 ; chan<nrchanwav ; chan++ ) {
      if( SpeechFlag[frame][chan] == S && Energy[frame][chan] <= (nrthres==0 ? (*thres) : thres[chan]) )
	SpeechFlag[frame][chan] = P ;
    } ;
  } ;

  return(_OK_) ;
}

int getNrActiveChan( int frame ) {
  int nractive = 0, chan ;

  for( chan=0 ; chan<nrchanwav ; chan++ )
    //if( OverlapFlag[frame][chan] == 1 )
    if( SpeechFlag[frame][chan] >= PUS )
      nractive++ ;

  return( nractive ) ;
}


// go through activity arrays (SpeechFlag[][]) and determine maxima of modloud in 1-regions
// only if max is higher than tres, this is a speech region!!!
void ReviseSpeechFlagsWithModLoudThres( float thres, int minlen=25, int saturationlen=50 ) {


#ifdef TESTLEVEL
  fprintf( stderr, "\nUse threshold (%f) on mod. loudness to correct S/NS-info ...\n", thres ) ;
#endif

  int frame, chan, i ;
 
  int* start = new int[nrchanwav] ;
  float* mlmax = new float[nrchanwav] ;

  // check first frame:
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    if( SpeechFlag[0][chan] == 1 ) {
      start[chan] = 0 ;
      mlmax[chan] = ModLoud[0][chan] ;
    } ;
  } ;

  // check rest:
  for( frame=1 ; frame<nrframe ; frame++ ) {

    for( chan=0 ; chan<nrchanwav ; chan++ ) {

      if( SpeechFlagOut[frame][chan] >= PUS ) {
	if( SpeechFlagOut[frame-1][chan] < PUS ) {
	  // start of speech-region!
	  start[chan] = frame ;
	  // reset max
	  mlmax[chan] = ModLoud[frame][chan] ;
	} else {
	  // within speech-region: search for max modloud
	  if( ModLoud[frame][chan] > mlmax[chan] ) 
	    mlmax[chan] = ModLoud[frame][chan] ;
	}
      } else if( SpeechFlagOut[frame][chan] < PUS ) {
	if( SpeechFlagOut[frame-1][chan] >= PUS ) {
	  // end of speech region
	  // evaluate mlmax
	  //if( mlmax[chan] < thres ) {
	  // use corresponding thres:
	  if(frame-start[chan] > saturationlen) {
	    if( mlmax[chan] <thres)
	      // saturation: use max thres
	      for( i=start[chan] ; i<=frame ; i++ )
		SpeechFlagOut[i][chan] = P ;
	  } else if(frame-start[chan] > minlen) {
	    if( mlmax[chan] < (thres/((float)(saturationlen-minlen)))*(float)(frame-start[chan]-minlen) )
	      for( i=start[chan] ; i<=frame ; i++ )
		SpeechFlagOut[i][chan] = P ;
	  } 
	  //if( (frame-start[chan] > minlen) && (mlmax[chan] <thres) ) {
	    // this is  probably not a speech region: reset flags
	  //for( i=start[chan] ; i<=frame ; i++ )
	  //  OverlapFlag[i][chan] = 0 ;
	  //} ;
	}
      } ;
    } ;
  } ;
 
  // check last frame
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    if( SpeechFlagOut[nrframe-1][chan] >= PUS ) {
      //if( mlmax[chan] < thres ) {
      if(  (frame-start[chan] > minlen) && (mlmax[chan] < thres) ) {
	// this is  probably not a speech region: reset flags
	for( i=start[chan] ; i<nrframe ; i++ )
	  SpeechFlagOut[i][chan] = P ;
      } ;
    } ;
  } ;


} ;








// if several channels are active, look at correlations between them to decide whether it's a
// real overlap or just a coupling of one voise into different channels! Therefore look into the
// spurts of the channels and calculate the average correlation of the overlapped region
// only apply threshold on overlaps which are longer than a minimal number of frames given
void UseCorrelations( float threshold = 1.0, int minframe = 0 ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Use correlation-mean per spurt to reject unreliable 'speech' regions (threshold: %f) ...\n", threshold ) ;
#endif


  int *overlap = new int[nrframe] ;
  float correlmean ;
  float modloudmean1, modloudmean2 ;
  int start, stop, i, j, k, frame, effective_len ;

  // use median filter!!!
  CListOfObj CorrelBuf ;
  CFloatObj *floatval ;

  // loop over all combinations of channels
  int n=0 ;
  for( i=0 ; i<nrchanwav ; i++ ) {
    
    for( j=i+1 ; j<nrchanwav ; j++ ) {
      
      // first pass: detect overlapping region between channel i and channel j
      for( frame=0 ; frame<nrframe ; frame++ ) {
	// reset array to detect overlaps
	overlap[frame]=0 ;
	//if( OverlapFlag[frame][i] == 1  && OverlapFlag[frame][j] == 1 )
	if( SpeechFlagOut[frame][i] >= PUS  && SpeechFlagOut[frame][j] >= PUS )
	  overlap[frame] = 1 ;
      } ;

      overlap[0] = 0 ;
      // second pass: use correlations to decide what to do
      for( frame=1 ; frame<nrframe ; frame++ ) {
	if( overlap[frame] == 1 && overlap[frame-1] == 0 ) {
	  // start of overlap: calc median of correlation and of modified loudness for whole segment!!!
	  // correlmean = Correl[frame][n] ; // old version, used mean
	  // reset counter and buffer:
	  effective_len = 0 ;
	  modloudmean1 = 0.0 ;
	  modloudmean2 = 0.0 ;
	  if( !CorrelBuf.isEmpty() )
	    CorrelBuf.removeAll() ;
	  if( SpeechFlagOut[frame][i] == S && SpeechFlagOut[frame][j] == S ) {
	    floatval = new CFloatObj( Correl[frame][n] ) ;
	    CorrelBuf.insertSorted( floatval ) ;
	    modloudmean1 += ModLoud[frame][i] ;
	    modloudmean2 += ModLoud[frame][j] ;
	    effective_len++ ;
	  } ;
	  start = frame ;
	} else if( overlap[frame] == 1 ) {
	  // within overlapped region
	  // correlmean += Correl[frame][n] ; old version, used mean
	  if( SpeechFlagOut[frame][i] == S && SpeechFlagOut[frame][j] == S ) {
	    floatval = new CFloatObj( Correl[frame][n] ) ;
	    CorrelBuf.insertSorted( floatval ) ;
	    modloudmean1 += ModLoud[frame][i] ;
	    modloudmean2 += ModLoud[frame][j] ;
	    effective_len++ ;
	  } ;
	} else if( overlap[frame] == 0 && overlap[frame-1] == 1 ) {
	  // end of overlapping region
	  stop = frame -1 ;
	  //correlmean /= (stop-start+1) ; old version, used mean
	  // go to (stop-start+1)/2-th entry in buffer (median!)
	  CListIterator it  ;
	  for( k=0, it=CorrelBuf.head() ; k<(effective_len)/2 ; ++it, k++ )
	    ;
	  correlmean = ((CFloatObj*)*it)->getData() ;
	  modloudmean1 /= (effective_len) ;
	  modloudmean2 /= (effective_len) ;

	  // wenn Correlation groesser als Schwelle, dann bleibt nur der Channel mit groesserer
	  // modfied loudness aktiv, der andere wird als inaktiv gekennzeichnet!!!
	  if( correlmean > threshold && effective_len > minframe ) {
	    if( modloudmean1 > modloudmean2 ) 
	      for( k=stop ; k>=start ; k-- )
		//OverlapFlag[k][j] = 0 ;
		SpeechFlagOut[k][j] = P ;
	    else
	      for( k=stop ; k>=start ; k-- )
		//OverlapFlag[k][i] = 0 ;
		SpeechFlagOut[k][i] = P ;
	  } ;
	} ;
      } ; 
      // naechste Channel-Kombination!
      n++;
    } ;
  } ;
  delete[] overlap ;
} ;


void DetectOverlap( int *overlap, int i, int j, float &percentofi, float &percentofj ) {

  int frame, count = 0 ;
  // first pass: detect overlapping region between channel i and channel j
  for( frame=0 ; frame<nrframe ; frame++ ) {
    // reset array to detect overlaps
    overlap[frame]=0 ;
    //if( OverlapFlag[frame][i] == 1  && OverlapFlag[frame][j] == 1 )
    if( SpeechFlagOut[frame][i] >= PUS  && SpeechFlagOut[frame][j] >= PUS ) {
      overlap[frame] = 1 ;
      count++ ;
    }
  } ;

  percentofi = (float)count / (float)CalcSpeechFrames( SpeechFlagOut, i ) ;
  percentofj = (float)count / (float)CalcSpeechFrames( SpeechFlagOut, j ) ;

}


// if several channels are active, look at correlations between them to decide whether it's a
// real overlap or just a coupling of one voise into different channels! Therefore look into the
// spurts of the channels and calculate the average correlation of the overlapped region
// only apply threshold on overlaps which are longer than a minimal number of frames given
void UseCorrelationsMultiPass( float threshold = 1.0, int minframe = 0, float maxoverlap=1.0, float minthreshold = 1.0, float stepsize=0.05 ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Use correlation-mean per spurt to reject unreliable 'speech' regions (threshold: %f) ...\n", threshold ) ;
#endif


  int *overlap = new int[nrframe] ;
  float correlmean, currentthres, ipercent, jpercent ;
  float modloudmean1, modloudmean2 ;
  int start, stop, i, j, k, frame, effective_len ;

  // use median filter!!!
  CListOfObj CorrelBuf ;
  CFloatObj *floatval ;

  // loop over all combinations of channels
  int n=0 ;
  for( i=0 ; i<nrchanwav ; i++ ) {
    
    for( j=i+1 ; j<nrchanwav ; j++ ) {

      currentthres = threshold ;

      DetectOverlap( overlap, i, j, ipercent, jpercent ) ;
      
      // do loop until max overlap between channels is under predefined threshold 
      while( ipercent > maxoverlap || jpercent > maxoverlap ) {


	overlap[0] = 0 ;
	// second pass: use correlations to decide what to do
	for( frame=1 ; frame<nrframe ; frame++ ) {
	  if( overlap[frame] == 1 && overlap[frame-1] == 0 ) {
	    // start of overlap: calc median of correlation and of modified loudness for whole segment!!!
	    // correlmean = Correl[frame][n] ; // old version, used mean
	    // reset counter and buffer:
	    effective_len = 0 ;
	    modloudmean1 = 0.0 ;
	    modloudmean2 = 0.0 ;
	    if( !CorrelBuf.isEmpty() )
	      CorrelBuf.removeAll() ;
	    if( SpeechFlagOut[frame][i] == S && SpeechFlagOut[frame][j] == S ) {
	      floatval = new CFloatObj( Correl[frame][n] ) ;
	      CorrelBuf.insertSorted( floatval ) ;
	      modloudmean1 += ModLoud[frame][i] ;
	      modloudmean2 += ModLoud[frame][j] ;
	      effective_len++ ;
	    } ;
	    start = frame ;
	  } else if( overlap[frame] == 1 ) {
	    // within overlapped region
	    // correlmean += Correl[frame][n] ; old version, used mean
	    if( SpeechFlagOut[frame][i] == S && SpeechFlagOut[frame][j] == S ) {
	      floatval = new CFloatObj( Correl[frame][n] ) ;
	      CorrelBuf.insertSorted( floatval ) ;
	      modloudmean1 += ModLoud[frame][i] ;
	      modloudmean2 += ModLoud[frame][j] ;
	      effective_len++ ;
	    } ;
	  } else if( overlap[frame] == 0 && overlap[frame-1] == 1 ) {
	    // end of overlapping region
	    stop = frame -1 ;
	    //correlmean /= (stop-start+1) ; old version, used mean
	    // go to (stop-start+1)/2-th entry in buffer (median!)
	    CListIterator it  ;
	    for( k=0, it=CorrelBuf.head() ; k<(effective_len)/2 ; ++it, k++ )
	      ;
	    correlmean = ((CFloatObj*)*it)->getData() ;
	    modloudmean1 /= (effective_len) ;
	    modloudmean2 /= (effective_len) ;
	    
	    // wenn Correlation groesser als Schwelle, dann bleibt nur der Channel mit groesserer
	    // modfied loudness aktiv, der andere wird als inaktiv gekennzeichnet!!!
	    if( correlmean > currentthres && effective_len > minframe ) {
	      if( modloudmean1 > modloudmean2 ) 
		for( k=stop ; k>=start ; k-- )
		  //OverlapFlag[k][j] = 0 ;
		  SpeechFlagOut[k][j] = P ;
	      else
		for( k=stop ; k>=start ; k-- )
		  //OverlapFlag[k][i] = 0 ;
		  SpeechFlagOut[k][i] = P ;
	    } ;
	  } ;
	} ;

	// check how many overlapping frames remain:
	DetectOverlap( overlap, i, j, ipercent, jpercent ) ;

#ifdef TEST_CORREL
	fprintf( stderr, "chan %d and %d: percentage overlaps: %f %f\n", i,j,ipercent,jpercent ) ;
#endif

	// reduce threshold for rejecting overlaps
	if( currentthres - stepsize >= minthreshold ) {  
	    currentthres -= stepsize ;
#ifdef TEST_CORREL
	    fprintf( stderr, "reduce threshold to %f\n", currentthres ) ;
#endif
	} else {
	  // minimum threshold reached!
	  ipercent = jpercent = maxoverlap ;
	}

      }
      
      // naechste Channel-Kombination!
      n++;
    } ;
  } ;
  delete[] overlap ;
} ;








// whenever a channel shows activity, look at correlations between that channel and the PZM-signals to decide whether it's a
// real speech or just a breath noise! Therefore look into the
// spurts of the channels and calculate the median/min/max correlation of ech speech region
// only use this threshold on medium length speech segments (typical for breaths)
// use autocorrelation to 'detect' regions where there is only breath
void UseCorrelationsWithPZM( float threshold = 0.0, int breathminlen=50, int breathmaxlen=125, int breathdistmin=150, int breathdistmax=500, int nrconsecutive=3 ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Use correlation-median per spurt to reject 'breath' regions (threshold: %f) ...\n", threshold ) ;
#endif


  //int *overlap = new int[nrframe] ;
  float correlmedian, correlmedianmax ;
  int start, stop, j, k, frame, chan, len ;

  // use median filter!!!
  CListOfObj *CorrelBuf = new CListOfObj[nrpzm] ;
  CFloatObj *floatval ;

  // collect start times and correlation values for possible breath regions!
  // buffers for start times of possible breath regions!
  CListOfObj *BreathStartInfo = new CListOfObj[nrchanwav] ;
  CListOfObj *BreathStopInfo = new CListOfObj[nrchanwav] ;  
  CIntObj *intval ;
  // buffers for start times of possible breath regions!
  CListOfObj *BreathCorrelInfo = new CListOfObj[nrchanwav] ;

  // collect correlation info with all pzm-files and compare with threshold 
  int n=0 ;
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    //OverlapFlag[0][chan] = 0 ;
    SpeechFlagOut[0][chan] = P ;
    // find spurts and collect and evaluate correlation info
    for( frame=1 ; frame<nrframe ; frame++ ) {
      //if( OverlapFlag[frame][chan] == 1 && OverlapFlag[frame-1][chan] == 0 ) {
      if( SpeechFlagOut[frame][chan] >= PUS && SpeechFlagOut[frame-1][chan] < PUS ) {
	// start of speech region: collect correlation data
	for( j=0 ; j<nrpzm ; j++ ) {
	  if( !CorrelBuf[j].isEmpty() )
	    CorrelBuf[j].removeAll() ;
	  floatval = new CFloatObj( CorrelPZM[frame][chan*nrpzm+j] ) ;
	  CorrelBuf[j].insertSorted( floatval ) ;
	}
	start = frame ;
	//} else if( OverlapFlag[frame][chan] == 1 ) {
      } else if( SpeechFlagOut[frame][chan] >= PUS ) {
	// within speech region: just collect correl info
	for( j=0 ; j<nrpzm ; j++ ) {
	  floatval = new CFloatObj( CorrelPZM[frame][chan*nrpzm+j] ) ;
	  CorrelBuf[j].insertSorted( floatval ) ;
	}
	//} else if( OverlapFlag[frame][chan] == 0 && OverlapFlag[frame-1][chan] == 1 ) {
      } else if( SpeechFlagOut[frame][chan] < PUS && SpeechFlagOut[frame-1][chan] >= PUS ) {
	// end of speech region
	stop = frame ;
	len = stop - start ;
	// has the spurt the 'right' length (typical breath length?)
	if( (len >= breathminlen) && (len <= breathmaxlen) ) {
	  intval = new CIntObj( start ) ;
	  BreathStartInfo[chan] += intval ;
	  intval = new CIntObj( stop-1 ) ;
	  BreathStopInfo[chan] += intval ;
	  CListIterator it  ;
	  correlmedianmax = 0.0 ;
	  for( j=0 ; j<nrpzm ; j++ ) {
	    for( k=0, it=CorrelBuf[j].head() ; k<(len)/2 ; ++it, k++ )
	      ;
	    correlmedian = ((CFloatObj*)*it)->getData() ;
	    if( correlmedian > correlmedianmax )
	      correlmedianmax = correlmedian ;
	  } ;
	  // add correlmedianmax to buffer
	  floatval = new CFloatObj( correlmedianmax ) ;
	  BreathCorrelInfo[chan] += floatval ;
	}
      }
    } ;
  } ;

  CListIterator it_start, it_stop, it_correl, it1, it2, it3 ;
  int count, dist, i ;
  float neighborcorrel ;

#ifdef TESTLEVEL2
  // control output: only for debugging!
  for( chan= 0 ; chan<nrchanwav ; chan++ ) {
    fprintf( stderr, "[Chan %d] Len Of Buffers: Start: %d, Stop: %d, Correl: %d\n",chan,  BreathStartInfo[chan].getNrEntries(), BreathStopInfo[chan].getNrEntries(), BreathCorrelInfo[chan].getNrEntries() ) ;

  
    for( i=0, it_start = BreathStartInfo[chan].head(), it_stop = BreathStopInfo[chan].head(), it_correl = BreathCorrelInfo[chan].head() ; it_start!=0 && it_stop!=0 && it_correl!=0 ; ++it_start, ++it_stop, ++it_correl, i++ )
      fprintf( stderr, "[Chan %d] [Breath %d]: %d %d %f\n", chan, i, ((CIntObj*)*it_start)->getData(), ((CIntObj*)*it_stop)->getData(), ((CFloatObj*)*it_correl)->getData() ) ;
  }
#endif






  // now BreathStartInfo[] contains all the start points of possible breath regions
  // and BreathStopInfo[] contains all the end points of possible breath regions
  // and BreathCorrelInfo[] contains the corresponding median correlation value (max to all pzms) of that breath region hypothesis

  // loop over all channels and compare correl with threshold if there are more possible breaths following!
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    // loop over all possible breaths
    for( it_start = BreathStartInfo[chan].head(), it_stop = BreathStopInfo[chan].head(), it_correl = BreathCorrelInfo[chan].head() ; it_start!=0 && it_stop!=0 && it_correl!=0 ; ++it_start, ++it_stop, ++it_correl ) {
      
      // how many following hypothesized breaths match the distance requirements?
      count=0 ;
      for( it1=it_start, it2=(+it_start), it3=(+it_correl) ; it1!=0 && it2!=0 && it3!=0; ++it1, ++it2, ++it3 ) {
	
	// do neighbors exist?
	//if( it2==0 || it3==0 )
	//  break ;

	dist = ((CIntObj*)*it2)->getData() - ((CIntObj*)*it1)->getData() ;
	neighborcorrel = ((CFloatObj*)*it3)->getData() ;

	// check distance to neighbor and correlation of neighboring breath!
	if( dist > breathdistmin && dist < breathdistmax && neighborcorrel < threshold )
	  count++ ;
	else
	  break ;
      }
      // how many preceding hypothesized breaths match the distance requirements?
      for( it1=it_start, it2=(-it_start), it3=(-it_correl) ; it1!=0 && it2!=0 && it3!=0; --it1, --it2, --it3 ) {

	// do neighbors exist?
	//if( it2==0 || it3==0 )
	//  break ;

	dist = ((CIntObj*)*it1)->getData() - ((CIntObj*)*it2)->getData() ;
	neighborcorrel = ((CFloatObj*)*it3)->getData() ;

	if( dist > breathdistmin && dist < breathdistmax && neighborcorrel < threshold )
	  count++ ;
	else
	  break ;
      }

      // apply threshold on consecutive breath hypotheses found (count+1 = number of consec. breaths)
      if( (count+1) >= nrconsecutive ) {
	// get correlation value:
	correlmedianmax = ((CFloatObj*)*it_correl)->getData() ;
	if( correlmedianmax < threshold )
	  // this does seem to be a breath region: reset to 'nonspeech'
	  for( k = ((CIntObj*)*it_start)->getData() ; k <= ((CIntObj*)*it_stop)->getData() ; k++ ) {
#ifdef TESTLEVEL2
	    fprintf(stderr, "frame %d, chan %d: RESET TO 'NONSPEECH'\n", k, chan ) ;
#endif
	    //OverlapFlag[k][chan] = 0 ;
	    SpeechFlagOut[k][chan] = P ;
	  }
      } ;
    }
 
  }

  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    // free memory for start, stop and correl info on breath hypos!
    if( !BreathStartInfo[chan].isEmpty() )
      BreathStartInfo[chan].removeAll() ;
    if( !BreathStopInfo[chan].isEmpty() )
      BreathStopInfo[chan].removeAll() ;
    if( !BreathCorrelInfo[chan].isEmpty() )
      BreathCorrelInfo[chan].removeAll() ;
  } ;

  for( chan=0 ; chan<nrpzm ; chan++ ) {
    // free memory off median-buffer for pzm-correlations! 
    if( !CorrelBuf[chan].isEmpty() ) 
	CorrelBuf[chan].removeAll() ;
  } ;

  delete[] CorrelBuf ;

  delete[] BreathStartInfo ;
  delete[] BreathStopInfo ;
  delete[] BreathCorrelInfo ;
} ;




// if several channels are active, look at correlations between them to decide whether it's a
// real overlap or just a coupling of one voise into different channels! Therefore look at each frame
// of each channel and calculate the mean correlation of some given buffer with buflen!
void UseCorrelationsPerFrame( float threshold = 1.0, int buflen=11  ) {

#ifdef TESTLEVEL
  fprintf( stderr, "\nUse median filtered (%d-point median) correlations (per frame) to reject unreliable 'speech' regions (threshold: %f) ...\n", buflen*2+1, threshold ) ;
#endif

  int *overlap = new int[nrframe] ;
  float correlmean, correlmedian, correlmax ;
  float modloudmean1, modloudmean2 ;
  int start, stop, i, j, k, l, frame, chan ;
  CListIterator it ;
  CListOfObj CorrelBuf ;
  CFloatObj *floatval ;

  // loop over all combinations of channels
  int n=0 ;
  for( i=0 ; i<nrchanwav ; i++ ) {
    
    for( j=i+1 ; j<nrchanwav ; j++ ) {
      
      // first pass: detect overlapping region between channel i and channel j
      for( frame=0 ; frame<nrframe ; frame++ ) {
	// reset array to detect overlaps
	overlap[frame]=0 ;
	//if( OverlapFlag[frame][i] == 1 && OverlapFlag[frame][j] == 1 )
	if( SpeechFlagOut[frame][i] >= PUS && SpeechFlagOut[frame][j] >= PUS )
	  overlap[frame] = 1 ;
      } ;

      //overlap[0] = 0 ;
      // second pass: use correlations to decide what to do
      for( frame=0 ; frame<nrframe ; frame++ ) {

	// reset variables for calculating means of correlation and modified loudness
	correlmean = 0.0 ;
	modloudmean1 = 0.0 ;
	modloudmean2 = 0.0 ;
	// check for overlap
	if( overlap[frame] == 1 ) {
	  // clear buffer for getting median
	  if( !CorrelBuf.isEmpty() )
	    CorrelBuf.removeAll() ;
	  // calculate mean and median of correlation and mean of mod. loudnesses around this frame 
	  for( k=( frame-buflen<0 ? 0 : frame-buflen ), l=0 ; k <= (frame+buflen > nrframe-1 ? nrframe-1 : frame+buflen) ; k++ ) {
	    if( Correl[k][n] != 0.0 ) {
	      floatval = new CFloatObj( Correl[k][n] ) ; 
	      CorrelBuf.insertSorted( floatval ) ;
	      correlmean += Correl[k][n] ; 
	      l++ ; // count number of used entries
	    }
	    modloudmean1 += ModLoud[k][i] ;
	    modloudmean2 += ModLoud[k][j] ;
	  } ;
	  correlmean /= l ;
	  for( k=0, it=CorrelBuf.head() ; k<l/2 ; k++, ++it )
	    ;
	  correlmedian = ((CFloatObj*)*it)->getData() ;
	  modloudmean1 /= l ;
	  modloudmean2 /= l ;

	  // compare with threshold!
	  //if( correlmean > threshold ) {
	  if( correlmedian > threshold ) {
	    if( modloudmean1 > modloudmean2 ) 
	      //OverlapFlag[frame][j] = 0 ;
	      SpeechFlagOut[frame][j] = P ;
	    else
	      //OverlapFlag[frame][i] = 0 ;
	      SpeechFlagOut[frame][i] = P ;
	  } ;
	} ;
      } ; 
      // naechste Channel-Kombination!
      n++;
    } ;
  } ;
  delete[] overlap ;
} ;



// whenever a channel shows activity, look at correlations between that channel and the PZM-signals to decide whether it's a
// real speech or just a breath noise! Therefore look into the
// spurts of the channels and calculate the median/min/max correlation of ech speech region
// only use this threshold on medium length speech segments (typical for breaths)
void UseCorrelationsWithPZMPerFrame( float threshold = 0.0, int buflen=25 ) {

#ifdef TESTLEVEL
  fprintf( stderr, "Use median filtered (%d-point median) correlation with PZM signals to reject 'breath' regions (threshold: %f) ...\n", buflen, threshold ) ;
#endif

  float correlmedian, correlmedianmax ;
  int  j, k, frame, chan, len ;
  CListIterator it  ;

  // use median filter!!!
  CListOfObj *CorrelBuf = new CListOfObj[nrpzm] ;
  CFloatObj *floatval ;

  // loop over all channels and look onti correlation with all pzm-files
  int n=0 ;
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    //OverlapFlag[0][chan] = 0 ;
    SpeechFlagOut[0][chan] = P ;
    // find speech-frames!
    for( frame=0 ; frame<nrframe ; frame++ ) {
      //if( OverlapFlag[frame][chan] == 1 ) {
      if( SpeechFlagOut[frame][chan] >= PUS ) {
	// calculate median of correlatins with all pzm-files
	correlmedianmax = 0.0 ;
	for( j=0 ; j<nrpzm ; j++ ) {
	  if( !CorrelBuf[j].isEmpty() )
	    CorrelBuf[j].removeAll() ;
	  // collect correlinfo around current frame (memorize how many frames used (len))
	  for( k=( frame-buflen >=0 ? frame-buflen : 0 ), len = 0 ; k<=(frame+buflen <= nrframe-1 ? frame+buflen : nrframe-1 ) ; k++ ) {
	    if( CorrelPZM[k][chan*nrpzm+j] != 0.0 ) {
	      floatval = new CFloatObj( CorrelPZM[k][chan*nrpzm+j] ) ;
	      CorrelBuf[j].insertSorted( floatval ) ;
	      len++ ;
	    } ;
	  } ;
	  // get median of corralation with j-th pzm signal
	  for( k=0, it=CorrelBuf[j].head() ; k<(len)/2 ; ++it, k++ )
	    ;
	  correlmedian = ((CFloatObj*)*it)->getData() ;
	  // is correlation with this pzm signal bigger than correlation with other pzm signals?
	  if( correlmedian > correlmedianmax )
	    correlmedianmax = correlmedian ;
	} ;
	if( correlmedianmax < threshold ) {
	  //OverlapFlag[frame][chan] = 0 ;
	  SpeechFlagOut[frame][chan] = P ;
	} ;
      } ;
    } ;
  } ;

  delete[] CorrelBuf ;
} ;




void PrintResults( int overlapwanted, EOutPutMode outputmode, char *speechlabel, char *nonspeechlabel, float OffSet=0.05, int realid=0, int indivout=0 ) {

  // local variables 
  int nractive, nractivelast, lastspeaker, frame, chan ; 
  
  // OUTPUT:
  if( overlapwanted ) {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITH overlap\n\n" ) ;
#endif
    
    // do overlap-output:
    // Version 1, from overlap-info:
    switch(outputmode) {
    case XML_MULT:
      for( frame=0 ; frame<nrframe ; frame++ ) {
	
	// first frame???
	if( frame == 0 ) {
	  // first frame of a dialogue:
	  // global track:
	  fprintf( globoutfp, "<Sync chan=\"default\" time=\"%.3f\"/>\n", frame/100.0 ) ;
	  fprintf( globoutfp, "%s\n", nonspeechlabel ) ;
	  
	  // process each channel-track
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    if( realid )
	      fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n", ChanId[chan], frame/100.0 ) ;
	     else 
	      fprintf( globoutfp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 ) ;
	    //fprintf( globoutfp, "%s\n", (OverlapFlag[frame][chan] == 1 ? speechlabel : nonspeechlabel ) );
	    fprintf( globoutfp, "%s\n", (SpeechFlagOut[frame][chan] >= PUS ? speechlabel : nonspeechlabel ) );
	    if( indivout ) {
	      fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 ) ;
	      //fprintf( outfp[chan], "%s\n", (OverlapFlag[frame][chan] == 1 ? speechlabel : nonspeechlabel ) ) ;
	      fprintf( outfp[chan], "%s\n", (SpeechFlagOut[frame][chan] >= PUS ? speechlabel : nonspeechlabel ) ) ;
	    }
	  }
	} else {
	  // all other frames:
	  // process channels:
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    // look into channels:
	    //if( OverlapFlag[frame][chan] == 1 && OverlapFlag[frame-1][chan] == 0 ) {
	    if( SpeechFlagOut[frame][chan] >= PUS && SpeechFlagOut[frame-1][chan] < PUS ) {
	      // this particular channel has switched from pause to speech
	      if( realid )
		fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n",ChanId[chan],  frame/100.0 ) ;
	      else
		fprintf( globoutfp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan,  frame/100.0 ) ;
	      fprintf( globoutfp, "%s\n", speechlabel ) ;
	      if( indivout ) {
		fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 ) ;
		fprintf( outfp[chan], "%s\n", speechlabel ) ;
	      }
	      //} else if( OverlapFlag[frame][chan] == 0 && OverlapFlag[frame-1][chan] == 1 ) {
	    } else if( SpeechFlagOut[frame][chan] < PUS && SpeechFlagOut[frame-1][chan] >= PUS ) {
	      // this particular channel has speech to pause
	      if( realid ) 
		fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n", ChanId[chan], frame/100.0 + OffSet ) ;
	      else 
		fprintf( globoutfp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 + OffSet ) ;
	      fprintf( globoutfp, "%s\n", nonspeechlabel ) ;
	      if( indivout ) {
		fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 + OffSet ) ;
		fprintf( outfp[chan], "%s\n", nonspeechlabel ) ; 
	      }
	    }
	  } ;	 		
	  
	} ;	    
      }
      break ;
    } ;
  } else {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITHOUT overlap\n\n" ) ;
#endif

  
    switch(outputmode) {
    case FrameWise:
     
      break ;
    case XML:

         
       break ;

 
    case XML_MULT:
      
  
      break ;
    } ;
   
  } ;
  

}


void PrintIntermediateResults( int overlapwanted, EOutPutMode outputmode, char *speechlabel, char *nonspeechlabel, float OffSet, FILE *fp ) {

  // local variables 
  int nractive, nractivelast, lastspeaker, frame, chan ; 
  
  // OUTPUT:
  if( overlapwanted ) {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITH overlap\n\n" ) ;
#endif
    
    // do overlap-output:
    // Version 1, from overlap-info:
    switch(outputmode) {
    case XML_MULT:
      for( frame=0 ; frame<nrframe ; frame++ ) {
	
	// first frame???
	if( frame == 0 ) {
	  // first frame of a dialogue:
	  // global track:
	  fprintf( fp, "<Sync chan=\"default\" time=\"%.3f\" />\n", frame/100.0 ) ;
	  fprintf( fp, "%s\n", nonspeechlabel ) ;
	  
	  // process each channel-track
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    //if (OverlapFlag[frame][chan] == 1 ) {
	    if (SpeechFlagOut[frame][chan] >= PUS ) {
	      fprintf( fp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 ) ;
	      fprintf( fp, "%s\n", speechlabel ) ;
	    } else {
	      fprintf( fp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 ) ;
	      fprintf( fp, "%s\n", nonspeechlabel ) ;
	    }
	  }
	} else {
	  // all other frames:
	  // process channels:
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    // look into channels:
	    //if( OverlapFlag[frame][chan] == 1 && OverlapFlag[frame-1][chan] == 0 ) {
	    if( SpeechFlagOut[frame][chan] >= PUS && SpeechFlagOut[frame-1][chan] < PUS ) {
	      // this particular channel has switched from pause to speech		
	      fprintf( fp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 ) ;
	      fprintf( fp, "%s\n", speechlabel ) ;
	      //} else if( OverlapFlag[frame][chan] == 0 && OverlapFlag[frame-1][chan] == 1 ) {
	    } else if( SpeechFlagOut[frame][chan] < PUS && SpeechFlagOut[frame-1][chan] >= PUS ) {
	      // this particular channel has speech to pause
	      fprintf( fp, "<Sync chan=\"%d\" time=\"%.3f\"/>\n", chan, frame/100.0 + OffSet ) ;
	      fprintf( fp, "%s\n", nonspeechlabel ) ;
	    }
	  } ;	 		
	  
	} ;	    
      }
      break ;
    } ;
  } else {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITHOUT overlap\n\n" ) ;
#endif

  
    switch(outputmode) {
    case FrameWise:
     
      break ;
    case XML:

         
       break ;

 
    case XML_MULT:
      
  
      break ;
    } ;
   
  } ;
  

}




void PrintResultsWithPZMCorrel( int overlapwanted, EOutPutMode outputmode, char *speechlabel, char *nonspeechlabel, float OffSet=0.05 ) {

  // local variables 
  int nractive, nractivelast, lastspeaker, frame, chan, i ; 
  
  float** pzmcorrelmean = new float*[nrchanwav];
  for( i=0 ; i<nrchanwav ; i++ )
    pzmcorrelmean[i] = new float[nrpzm] ;
  int*   count = new int[nrchanwav] ;

  // OUTPUT:
  if( overlapwanted ) {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITH overlap\n\n" ) ;
#endif

    // do overlap-output:
    // Version 1, from overlap-info:
    switch(outputmode) {
    case XML_MULT:
      for( frame=0 ; frame<nrframe ; frame++ ) {
	
	// first frame???
	if( frame == 0 ) {
	  // first frame of a dialogue:
	  // default channel:
	  fprintf( globoutfp, "<Sync chan=\"default\" time=\"%.3f\"/>\n", frame/100.0 ) ;
	  fprintf( globoutfp, "%s\n", nonspeechlabel ) ;
	 
	  
	  // process each channel separately
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    //if (OverlapFlag[frame][chan] == 1 ) {
	    if (SpeechFlag[frame][chan] >= PUS ) {
	      for( i=0 ; i<nrpzm ; i++ )
		pzmcorrelmean[chan][i] = CorrelPZM[frame][chan*nrpzm+i] ;
	      count[chan]=0 ;
	      fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n",  ChanId[chan], frame/100.0 ) ;
	      fprintf( globoutfp, "%s\n", speechlabel ) ;
	      fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 ) ;
	      fprintf( outfp[chan], "%s\n", speechlabel ) ;
	    } else {
	      fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n", ChanId[chan], frame/100.0 ) ;
	      fprintf( globoutfp, "%s\n", nonspeechlabel ) ;
	      fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 ) ;
	      fprintf( outfp[chan], "%s\n", nonspeechlabel ) ;
	    } ;
	  }
	} else {
	  // all other frames:
	  // process channels:
	  for( chan=0 ; chan<nrchanwav ; chan++ ) {
	    // look into channels:
	    //if( OverlapFlag[frame][chan] == 1 && OverlapFlag[frame-1][chan] == 0 ) {
	    if( SpeechFlag[frame][chan] >= PUS && SpeechFlag[frame-1][chan] < PUS ) {
	      // this particular channel has switched from pause to speech
	      // reset variables for calculating pzmcorrel mean
	      for( i=0 ; i<nrpzm ; i++ )
		pzmcorrelmean[chan][i] = CorrelPZM[frame][chan*nrpzm+i] ;
	      count[chan]=0;
	      // print new speech label
	      fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n", ChanId[chan], frame/100.0 ) ;
	      fprintf( globoutfp, "%s\n", speechlabel ) ;
	      fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 ) ;
	      fprintf( outfp[chan], "%s\n", speechlabel ) ;
	      //} else if( OverlapFlag[frame][chan] == 0 && OverlapFlag[frame-1][chan] == 1 ) {
	    } else if( SpeechFlag[frame][chan] < PUS && SpeechFlag[frame-1][chan] >= PUS ) {
	      // this particular channel has switched from speech to pause
	      // calc mean and finish last 'speech' entry
	      for( i=0 ; i<nrpzm ; i++ ) {
		pzmcorrelmean[chan][i] /= count[chan] ;
		fprintf( globoutfp, "%f ", pzmcorrelmean[chan][i] ) ;
	      } 
	      fprintf( globoutfp, "\n" ) ;
	      // print 'nonspeech' entry
	      fprintf( globoutfp, "<Sync chan=\"%s\" time=\"%.3f\"/>\n", ChanId[chan], frame/100.0 + OffSet ) ;
	      fprintf( globoutfp, "%s\n", nonspeechlabel ) ;
	      fprintf( outfp[chan], "<Sync time=\"%.3f\">\n", frame/100.0 + OffSet ) ;
	      fprintf( outfp[chan], "%s\n", nonspeechlabel ) ; 
	      //} else if(OverlapFlag[frame][chan] == 1) {
	    } else if(SpeechFlag[frame][chan] >= PUS) {
	      // within 'speech' spurt
	      for( i=0 ; i<nrpzm ; i++ )
		pzmcorrelmean[chan][i] += CorrelPZM[frame][chan*nrpzm+i] ;
	      count[chan]++ ;
	    } 
	  } ;	 		
	  
	} ;	    
      }
      break ;
    } ;
  } else {
#ifdef TESTLEVEL
    fprintf( stderr, "Output WITHOUT overlap\n\n" ) ;
#endif

  
    switch(outputmode) {
    case FrameWise:
     
      break ;
    case XML:

         
       break ;

 
    case XML_MULT:
      
  
      break ;
    } ;
   
  } ;
 
  delete[] count ;
  delete[] pzmcorrelmean ;

}





void PrintFooter( EOutPutMode outputmode, int realid=0, int indivout=0 ) {
  // local variables
  int i ;

    
  // header and footer:
  switch( outputmode ) { 
  case XML:
    for( i=0 ; i<nrchanwav ; i++ ) {
      // finish last entry
      fprintf( outfp[i], "</Turn>\n" ) ;
      fprintf( outfp[i], "</Section>\n" ) ;
      fprintf( outfp[i], "</Episode>\n" ) ;
      fprintf( outfp[i], "</Trans>\n" ) ;
      // correct header
      // correct header: now length of file is known!
      rewind( outfp[i] ) ;
      fprintf( outfp[i], "<?xml version=\"1.0\"?>\n" ) ;
      fprintf( outfp[i], "<!DOCTYPE Trans SYSTEM \"trans-13.dtd\">\n" ) ;
      fprintf( outfp[i], "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
      fprintf( outfp[i], "<Episode>\n" ) ;
      fprintf( outfp[i], "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0 ) ;
      fprintf( outfp[i], "<Turn startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0  ) ;
    } ;
     // finish last entry
      fprintf( globoutfp, "</Turn>\n" ) ;
      fprintf( globoutfp, "</Section>\n" ) ;
      fprintf( globoutfp, "</Episode>\n" ) ;
      fprintf( globoutfp, "</Trans>\n" ) ;
      // correct header
      // correct header: now length of file is known!
      rewind( globoutfp ) ;
      fprintf( globoutfp, "<?xml version=\"1.0\"?>\n" ) ;
      fprintf( globoutfp, "<!DOCTYPE Trans SYSTEM \"trans-13.dtd\">\n" ) ;
      fprintf( globoutfp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
      fprintf( globoutfp, "<Episode>\n" ) ;
      fprintf( globoutfp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0 ) ;
      fprintf( globoutfp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0  ) ;
    break ;

  case XML_MULT:
    if( indivout ) {
      for( i=0 ; i<nrchanwav ; i++ ) {
	// finish last entry
	fprintf( outfp[i], "</Turn>\n" ) ;
	fprintf( outfp[i], "</Section>\n" ) ;
	fprintf( outfp[i], "</Episode>\n" ) ;
	fprintf( outfp[i], "</Trans>\n" ) ;
	// correct header
	// correct header: now length of file is known!
	rewind( outfp[i] ) ;
	fprintf( outfp[i], "<?xml version=\"1.0\"?>\n" ) ;
	fprintf( outfp[i], "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
	fprintf( outfp[i], "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
	fprintf( outfp[i], "<Episode>\n" ) ;
	fprintf( outfp[i], "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0 ) ;
	fprintf( outfp[i], "<Turn startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0  ) ;
      } ;
    }
    // finish last entry
    fprintf( globoutfp, "</Turn>\n" ) ;
    fprintf( globoutfp, "</Section>\n" ) ;
    fprintf( globoutfp, "</Episode>\n" ) ;
    fprintf( globoutfp, "</Trans>\n" ) ;
    // correct header
    // correct header: now length of file is known!
    rewind( globoutfp ) ;
    fprintf( globoutfp, "<?xml version=\"1.0\"?>\n" ) ;
    fprintf( globoutfp, "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
    fprintf( globoutfp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
    fprintf( globoutfp, "<Episode>\n" ) ;
    fprintf( globoutfp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0 ) ;
    fprintf( globoutfp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0  ) ;
    break ;
    
  case FrameWise:
    // do nothing
    break ;
  } ;
}


void PrintIntermediateFooter( EOutPutMode outputmode, FILE *fp ) {
  // local variables
  int i ;

    
  // header and footer:
  switch( outputmode ) { 
  case XML:
 
    break ;

  case XML_MULT:
    // finish last entry
    fprintf( fp, "</Turn>\n" ) ;
    fprintf( fp, "</Section>\n" ) ;
    fprintf( fp, "</Episode>\n" ) ;
    fprintf( fp, "</Trans>\n" ) ;
    // correct header
    // correct header: now length of file is known!
    rewind( fp ) ;
    fprintf( fp, "<?xml version=\"1.0\"?>\n" ) ;
    fprintf( fp, "<!DOCTYPE Trans SYSTEM \"trans-13-icsi.dtd\">\n" ) ;
    fprintf( fp, "<Trans scribe=\"dummy\" audio_filename=\"%s\" version=\"4\" version_date=\"010102\">\n", "dummy.wav" ) ;
    fprintf( fp, "<Episode>\n" ) ;
    fprintf( fp, "<Section type=\"report\" startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0 ) ;
    fprintf( fp, "<Turn startTime=\"0\" endTime=\"%.8e\">\n", (nrframe-1)/100.0  ) ;
    break ;
    
  case FrameWise:
    // do nothing
    break ;
  } ;
}




//------------------------------- main ----------------------------------------

// main prg.
int main( int argc, char *argv[] )
{
  int i, chan, frame, tmpframe, pzm ;
  // open files
  if( argc < 5) 
    {   fprintf(stderr,"USAGE: spdtest <akupre-cfg-file> <spnonsp-chan-cfg-file> <spnonsp-chan-cfg-file-secondpass> <tmppath> <wavfile1> <wavfile2> ... <wavfileN> <outfile> <pzmfile1> ... <pzmfileN> <nrpzm>\n");
    return _ERR_;
    }
  
  // set filepointers
  chanfp = fopen( argv[1], "r+" );
  IF_ERROR_RETURN_S( chanfp == 0, "can't open akupre-cfg-file:", argv[1]);
  spnonspchancfgfp = fopen( argv[2], "r+" );
  IF_ERROR_RETURN_S( spnonspchancfgfp == 0, "can't open first channel-specific spnonsp-cfg-file:", argv[2]);
  spnonspchancfgfp2 = fopen( argv[3], "r+" );
  IF_ERROR_RETURN_S( spnonspchancfgfp2 == 0, "can't open second channel-specific spnonsp-cfg-file:", argv[3]);
  
  // derive parameters from commandline args
  nrpzm = strtol( argv[argc-1], NULL, 10 ) ;
  nrchanwav = argc-nrpzm-7 ;
  nrskip = 0 ;
  pzmfileindex = argc-nrpzm-1 ;
  wavfileoffset = 5 ; 
  outfileindex = nrchanwav+wavfileoffset ;
  tmppathindex = 4 ;

   
  if( nrpzm == 0 ) {
    fprintf( stderr, "ERROR: at least one PZM-file is required for this version\n" ) ;
    fprintf(stderr,"USAGE: spdtest <akupre-cfg-file> <spnonsp-chan-cfg-file> <spnonsp-chan-cfg-file-secondpass> <tmppath> <wavfile1> <wavfile2> ... <wavfileN> <outfile> <pzmfile1> ... <pzmfileN> <nrpzm>\n");
    return _ERR_;
  } ;



  // get ChanIds 
  int MaxChanIdLen = 2 ;
  ChanId = new char*[nrchanwav] ;
  char *tmpchar ;
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    // allocate memory
    ChanId[chan] = new char[MaxChanIdLen] ;
  
    // parse filenames of wav-files
    tmpchar = strrchr( argv[wavfileoffset+chan], '.' ) ;
    tmpchar--;
    strncpy( ChanId[chan], tmpchar, 1 ) ;
    ChanId[chan][1] = '\0'  ;

    //fprintf( stderr, "ChanId[%d]=%s\n", chan, ChanId[chan] ) ;
  } ;
  PZMId = new char*[nrpzm];
  for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
    // allocate memory
    PZMId[pzm] = new char[MaxChanIdLen] ;
  
    // parse filenames of wav-files
    tmpchar = strrchr( argv[pzmfileindex+pzm], '.' ) ;
    tmpchar--;
    strncpy( PZMId[pzm], tmpchar, 1 ) ;
    PZMId[pzm][1] = '\0'  ;

    //fprintf( stderr, "ChanId[%d]=%s\n", chan, ChanId[chan] ) ;
  } ;


  // calculate skews between channels:
  // theres seems to be an almost deterministic skew (delay) between neighboring channels
  // which seems to be 64 samples (not for the first two channels but doing this is better
  // than nothing, so skip the first 64*(nrchan-1-i) samples (i.e. 128*(nrchan-1-i) bytes)
  // for all the channels
  ByteSkip = new int[nrchanwav];
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    switch( ChanId[chan][0] ) {
    case '0':
    case '1':
    case '2': 
    case '3': 
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      ByteSkip[chan] = (15-strtol(ChanId[chan],NULL,10))*128 ;
#ifdef TESTLEVEL
      fprintf( stderr, "chan: %d, Id: %s, skew: %d\n", chan, ChanId[chan], ByteSkip[chan] ) ;
#endif
      break;
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
      ByteSkip[chan] = ('F'-ChanId[chan][0])*128 ;
#ifdef TESTLEVEL
      fprintf( stderr, "chan: %d, Id: %s, skew: %d\n", chan, ChanId[chan], ByteSkip[chan] ) ;
#endif
      break;
    } ;
  }  

  ByteSkipPZM = new int[nrpzm]; 
  for( pzm=0 ; pzm<nrpzm ; pzm++ ) {
    switch( PZMId[pzm][0] ) {
    case '0':
    case '1': 
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      ByteSkipPZM[pzm] = (15-strtol(PZMId[pzm],NULL,10))*128 ;
#ifdef TESTLEVEL
      fprintf( stderr, "pzm: %d, Id: %s, skew: %d\n", pzm, PZMId[pzm], ByteSkipPZM[pzm] ) ;
#endif
      break;
    case 'A':
    case 'B':
    case 'C':
    case 'D':
    case 'E':
    case 'F':
      ByteSkipPZM[pzm] = ('F'-PZMId[pzm][0])*128 ;
#ifdef TESTLEVEL
      fprintf( stderr, "pzm: %d, Id: %s, skew: %d\n", pzm, PZMId[pzm], ByteSkipPZM[pzm] ) ;
#endif
      break;
    } ;
  }  


  // read Tool-related params
  CParEnum OutputPar( "Tools.Result.OutputMode", "FrameWise, MUC, XML, MUC_OLD, XML_MULT", chanfp ) ;
  EOutPutMode OutputMode = (EOutPutMode)OutputPar.Par ;
  CParString SpeechLabel( "Tools.Result.SpeechLabel", chanfp, " " ) ;
  CParString NonspeechLabel( "Tools.Result.SilentLabel", chanfp, ".." ) ;
  CParFloat  SpeechOffset( "Tools.Result.SpeechOffset", chanfp, 0.0 ) ;
  CParInt ResultRealId( "Tools.Result.RealId", chanfp, 0 ) ;
  CParInt ResultIndivOut( "Tools.Result.IndivOut", chanfp, 0 ) ;

  CParBool NormSpecialFeatChan( "Tools.NormSpecialFeatChan", chanfp, 1 ) ;
  CParBool NormSpecialFeatChanSecondPass( "Tools.NormSpecialFeatChanSecondPass", chanfp, 0 ) ;
  CParFloat NormSpecialFeatChanPerc( "Tools.NormSpecialFeatChanPerc", chanfp, 0.0 ) ; // use percentile of max instead of max!


  CParFloat** NormSpecialFeatChanPercIndiv = new CParFloat*[nrchanwav] ;
  char *tmpperc= new char[strlen("Tools.NormSpecialFeatChanPercIndiv.Chan")+3];
  for( chan=0 ; chan<nrchanwav ; chan++ ) {
    sprintf( tmpperc, "%s%s\0",  "Tools.NormSpecialFeatChanPercIndiv.Chan", ChanId[chan] ) ;
    NormSpecialFeatChanPercIndiv[chan] = new CParFloat( tmpperc, chanfp, 0.1 ) ;
  }

  //CParBool UseManualMinMax( "Tools.UseManualMinmax", chanfp, 0 ) ; // read minima and maxima from file!
  CParBool UseMaxNorm( "Tools.UseMaxToNormLoud", chanfp, 1 ) ;
  CParFloat LoudnessTauRise( "Tools.LoudnessTauRise", chanfp, 0.0 ) ;
  CParFloat LoudnessTauFall( "Tools.LoudnessTauFall", chanfp, 0.0 ) ;
  CParInt MinMaxBegFrame( "Tools.MinMaxBegFrame", chanfp, 60000 ) ;
  CParInt MinMaxRunLen( "Tools.MinMaxRunLen", chanfp, 6000 ) ;
  CParInt MinMaxNrRun( "Tools.MinMaxNrRun", chanfp, 60000 ) ;


  CParBool UseModLoudTimesZCRate( "Tools.UseModLoudTimesZCRate", chanfp, 1 ) ;
  CParBool UsePZMEnergy( "Tools.UsePZMEnergy", chanfp, 0 ) ;

  CParFloat CorrelationThres( "Tools.CorrelationThres", chanfp, 1.0 ) ;  // start with this threshold
  CParFloat CorrelationMinThres( "Tools.CorrelationMinThres", chanfp, 1.0 ) ;  // go down to this threshold
  CParFloat CorrelationStepSize( "Tools.CorrelationStepSize", chanfp, 0.05 ) ;  // go down using thsi stepsize
  CParFloat CorrelationMaxOverlap( "Tools.CorrelationMaxOverlap", chanfp, 1.0 ) ;  // max percent of overlap for two channels!

  CParInt   CorrelThresMinLen( "Tools.CorrelThresMinLen", chanfp, 0 );
  CParInt CorrelationWinLen( "Tools.CorrelationWinLen", chanfp, 768 ) ;
  CParFloat CorrelationShift( "Tools.CorrelationShift", chanfp, 100 ) ;
  CParFloat CorrelationToPZMMin( "Tools.CorrelationToPZMMin", chanfp, 0.0 );
  CParInt   BreathMinLen( "Tools.BreathMinLen", chanfp, 50 ) ;
  CParInt   BreathMaxLen( "Tools.BreathMaxLen", chanfp, 125 ) ;
  CParInt   BreathMinDist( "Tools.BreathMinDist", chanfp, 150 ) ;
  CParInt   BreathMaxDist( "Tools.BreathMaxDist", chanfp, 500 ) ;
  CParInt   NrConsecutiveBreath( "Tools.NrConsecutiveBreath", chanfp, 3 ) ;

  CParBool UseCorrelPerFrame( "Tools.UseCorrelPerFrame", chanfp, 0 ) ;
  CParBool UseCorrelPerSpurt( "Tools.UseCorrelPerSpurt", chanfp, 1 ) ;
  if( UseCorrelPerSpurt.Par && UseCorrelPerFrame.Par ) {
    fprintf( stderr, "Can't apply both methods for using correlations (per frame and per spurt) at the same time\n" ) ;
    exit(-1) ;
  } ;
  CParInt CorrelationSmoothLen( "Tools.CorrelationSmoothLen", chanfp, 10 ) ;
  if( CorrelationSmoothLen.Par <= 0 ) {
    fprintf( stderr, "CorrelationSmoothLen must be greater than zero\n" ) ;
    exit(-1) ;
  } ;

  CParInt SmoothWindowLen( "Tools.Result.SmoothWindowLen", chanfp, 41 ) ;
  CParBool OverlapWanted( "Tools.Result.OverlapWanted", chanfp, 0 ) ;
  
  CParBool SmoothEnergyWanted( "Tools.Result.SmoothEnergyWanted", chanfp, 0 ) ;
  CParInt  SmoothEnergyDelta( "Tools.Result.SmoothEnergyDelta", chanfp, 0 ) ;

  CParBool UseEnergyToCorrectSpnonsp( "Tools.UseEnergyToCorrectSpnonsp", chanfp, 0 ) ;
  CParBool UseIndividualThres( "Tools.UseIndividualThres", chanfp, 0 ) ;

  CParFloat ModLoudMaxThres( "Tools.ModLoudMaxThres", chanfp, 0.0 ) ;
  CParInt ModLoudThresMinLen( "Tools.ModLoudThresMinLen", chanfp, 0 ) ;
  CParInt ModLoudThresSaturationLen( "Tools.ModLoudThresSaturationLen", chanfp, 0 ) ;

  CParBool CtrlOutput( "Tools.Ctrl.Output", chanfp, 0 ) ;

  CParBool UseLapelNet( "Tools.UseLapelNet", chanfp, 0 ) ;

  
  CParBool SecondPassWanted( "Tools.SecondPassWanted", chanfp, 0 ) ;
  CParBool SecondPassThres( "Tools.SecondPassThres", chanfp, 0 ) ;
  CParFloat MaxSens( "Tools.MaxSensitivity", chanfp, 1.5 ) ;
  CParFloat MinSens( "Tools.MinSensitivity", chanfp, 0.66 ) ;
  CParFloat MaxSpeechPercentSecondPass( "Tools.MaxSpeechPercentSecondPass", chanfp, 1.0 ) ;
  CParInt ForwardTime( "Tools.ForwardTime", chanfp, 60 ) ; // seconds
  CParInt BackwardTime( "Tools.BackwardTime", chanfp, 60 ) ; // seconds
  CParFloat SigmoidSlope( "Tools.SigmoidSlope", chanfp, 0.1 ) ; // 1/(1+exp(slope/Time*f)) with Time = Forward or BackwardTime

  // initialize acoustic preprocessing and speech non speech detection of all channels
  InitAkuPreAndSpNonSp( argv, UseModLoudTimesZCRate.Par, UsePZMEnergy.Par, CorrelationWinLen.Par ) ;

  // set Labels to empty string if requested!
  if( strcmp( SpeechLabel.Par, "NONE" ) == 0 ) 
    strcpy( SpeechLabel.Par, "" ) ;
  if( strcmp( NonspeechLabel.Par, "NONE" ) == 0 ) 
    strcpy( NonspeechLabel.Par, "" ) ;
  

  // start preprocessing of all channels
  if ( StartAkuPreAll( argv ) == -1 ) {
    fprintf( stderr, "ERROR: Could not start acoustic preprocessing of all channels!\n" ) ;
    exit(-1);
  } ;
  if( StartSpNonSpAll( argv, UseLapelNet.Par, tmppathindex ) == -1 ) {
    fprintf( stderr, "ERROR: Could not start spnonsp of all channels!\n" ) ;
    exit(-1);
  } ;
  
  // open outfiles
  char tmp[MaxLineLength] ;
  outfp = new FILE*[nrchanwav] ;
  if( ResultIndivOut.Par ) {
    for( chan=0 ; chan<nrchanwav ; chan++ ) {
      sprintf( tmp, "%s.%d.%s", argv[outfileindex], chan, OutputMode == FrameWise ? "fwise" : "trs" ) ;
      outfp[chan] = fopen( tmp, "w" ) ;
      if( outfp[chan] == 0 ) {
	ERROR_MSG_S("can't open %d-th outfile %s!", chan, tmp );
	outfp[chan] = stderr ;
      }
    }
  } ;
  
  globoutfp = fopen( argv[outfileindex], "w" ) ;

  sprintf( tmp, "%s.log", argv[outfileindex] ) ;
  logfp = fopen( tmp, "w" ) ;

  // output headers into all outfiles
  PrintHeader(OutputMode, ResultRealId.Par, ResultIndivOut.Par) ;
   
  // initialize array of pointers to feature vectors
  prefp = new SPreFeature*[nrchanwav];
  prefppzmfile = new SPreFeature*[nrpzm] ;

  // count frames of mixfile to determine length
  nrframe = CountFrames( argv ) ;
#ifdef TESTLEVEL
  fprintf( stderr, "nr of frames: %d\n", nrframe ) ;
#endif 

  // determine minima resp maxima of special features!
  //GetMinAndMax( NormSpecialFeatChanPerc.Par, LoudnessTauRise.Par, LoudnessTauFall.Par, NormSpecialFeatChanPercIndiv, MinMaxBegFrame.Par, MinMaxRunLen.Par, MinMaxNrRun.Par ) ;
  GetMinAndMax( NormSpecialFeatChanPerc.Par ) ;

  //CalcEntropy( argv, UseLapelNet.Par, tmppathindex ) ;

  // do S/NS detection, therefore normalize features ... (->Energy[][], ->ModLoud[][], ->SpeechFlag[][], initialize SpeechFlag2[][] and SpeechFlagout[][] with 'P' ) ;
  GetSpNonSpAndEnergy( argv, NormSpecialFeatChan.Par, NormSpecialFeatChanSecondPass.Par, NormSpecialFeatChanPerc.Par, UsePZMEnergy.Par, UseModLoudTimesZCRate.Par, UseMaxNorm.Par ) ;

  FILE *tmpfp ;
  char tmpfilename[MaxLineLength] ;
  //sprintf( tmpfilename, "%s-AfterFirstPass.trs", argv[outfileindex] ) ;
  //tmpfp = fopen( tmpfilename, "w" ) ;
  //PrintIntermediateHeader( OutputMode, tmpfp ) ;
  //PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
  //PrintIntermediateFooter( OutputMode, tmpfp ) ;
  //fclose(tmpfp) ;


  

  if( SecondPassWanted.Par ) {
    sprintf( tmpfilename, "%s-BeforeSecondPassSpNonSp.trs", argv[outfileindex] ) ;
    tmpfp = fopen( tmpfilename, "w" ) ;
    MergeFirstAndSecondPassSpNonSp() ;
    PrintIntermediateHeader( OutputMode, tmpfp ) ;
    PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
    PrintIntermediateFooter( OutputMode, tmpfp ) ;
    fclose(tmpfp) ;

    GetSpNonSpSecondPass(MaxSens.Par, MinSens.Par, ForwardTime.Par, BackwardTime.Par, SigmoidSlope.Par, MaxSpeechPercentSecondPass.Par) ;

    if( SecondPassThres.Par ) {
      int maxspeechlen = (int)((SpNonSp[0]->getSiToSp()+SpNonSp[0]->getSpToSi())*1.5) ;
      //fprintf( stderr, "Max Speech Length for Second Pass: %d\n", maxspeechlen ) ;
      ReviseSecondPassOutput( maxspeechlen ) ;
      sprintf( tmpfilename, "%s-AfterSecondPassSpNonSpWithMaxLen.trs", argv[outfileindex] ) ;
    } else {
      sprintf( tmpfilename, "%s-AfterSecondPassSpNonSpNoMaxLen.trs", argv[outfileindex] ) ;
    } ;

    MergeFirstAndSecondPassSpNonSp() ;
    
    tmpfp = fopen( tmpfilename, "w" ) ;
    MergeFirstAndSecondPassSpNonSp() ;
    PrintIntermediateHeader( OutputMode, tmpfp ) ;
    PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
    PrintIntermediateFooter( OutputMode, tmpfp ) ;
    fclose(tmpfp) ;
  } else {
    // dummy call to move SpeechFlag -> SpechFlagOut
    MergeFirstAndSecondPassSpNonSp() ;
  }

  if( CtrlOutput.Par ) {
    fprintf( stderr, "ENERGIES before smoothing\n" ) ;
    PrintEnergyArray( stderr ) ;
    PrintModLoudArray( stderr ) ;
  } ;

  if( SmoothEnergyWanted.Par ) {
    SmoothEnergies( SmoothEnergyDelta.Par) ; // ->Energy[][]
    SmoothModLoud( SmoothEnergyDelta.Par ) ; // ->ModLoud[][]
  } 

  if( CtrlOutput.Par ) {
    fprintf( stderr, "ENERGIES after smoothing\n" ) ;
    PrintEnergyArray( stderr ) ;
    PrintModLoudArray( stderr ) ;
  } ;

  if( CtrlOutput.Par ) {
    fprintf( stderr, "SPEECHFLAGS before energy thresholding\n" ) ;
    PrintSpeechFlagArray( stderr ) ;
  } ;

  if( UseEnergyToCorrectSpnonsp.Par ) {
    if( UseIndividualThres.Par ) {
      // call matlab script to calcultae Thresholds: not yet implemented
      float *Thres = new float[nrchanwav] ;
      for( chan=0 ; chan<nrchanwav ; chan++ )
	Thres[chan] = -5.0 ;
      CorrectSpNonSpWithEnergyThres( nrchanwav, Thres ) ; // ->SpeechFlag[][]
      delete[] Thres ;
    } else {
      // use global Threshold
      float globThres = -5.0 ;
      CorrectSpNonSpWithEnergyThres( 0, &globThres ) ; // ->SpeechFlag[][] 
    }
  } ;

  if( CtrlOutput.Par ) {
    fprintf( stderr, "SPEECHFLAGS after energy thresholding\n" ) ;
    PrintSpeechFlagArray( stderr ) ;
  } ;

  // search for active channel for each frame: one channel at a time only!!!! 
  // (SpeechFlag[][], ModLoud[][]->Channel[]: mark channel with highest modloud, if several are active) 
  // (SpeechFlag[][], ModLoud[][]->OverlapFlag[][]: mark all active channels
  
  //GetActiveChannel() ; // T.P. 02/06/2002
  
  //if( CtrlOutput.Par ) {
  //fprintf( stderr, "Active CHANNEL before smoothing\n" ) ;
  //PrintChannelArray( stderr ) ;
  //} ;

  sprintf( tmpfilename, "%s-AfterSpNonSp_BeforeMLThres.trs", argv[outfileindex] ) ;
  tmpfp = fopen( tmpfilename, "w" ) ;
  PrintIntermediateHeader( OutputMode, tmpfp ) ;
  PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
  PrintIntermediateFooter( OutputMode, tmpfp ) ;
  fclose(tmpfp) ;
 
  // version 1: just use a threshold on the max modloud found on spurts to reject them.
  // hence: do more restrict speech-nonspeech-detection (when uncertain -> nonspeech
  ReviseSpeechFlagsWithModLoudThres( ModLoudMaxThres.Par, ModLoudThresMinLen.Par, ModLoudThresSaturationLen.Par ) ; // ->SpeechFlagOut

  sprintf( tmpfilename, "%s-AfterMLThres_BeforeCorrel.trs", argv[outfileindex] ) ;
  tmpfp = fopen( tmpfilename, "w" ) ;
  PrintIntermediateHeader( OutputMode, tmpfp ) ;
  PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
  PrintIntermediateFooter( OutputMode, tmpfp ) ;
  fclose(tmpfp) ;
 
  if( CtrlOutput.Par ) {
    fprintf( stderr, "Active CHANNEL after smoothing\n" ) ;
    PrintChannelArray( stderr ) ;
  } ;


  // calculate normalized interchannel crosscorrelation (->Correl[][] ->CorrelPZM[][] )
  int frames ;
  //GetCorrelationsOnOverlapsAndSpeech( frames, CorrelationWinLen.Par, CorrelationShift.Par ) ;

#ifdef TESTLEVEL
  fprintf( stderr, "CorrelThres: %f, CorrelPzmMin: %f\n", CorrelationThres.Par, CorrelationToPZMMin.Par ) ;
#endif

  if( CorrelationThres.Par < 1.0 ||  CorrelationToPZMMin.Par != 0.0 ) {
    GetCorrelationsOnOverlapsAndSpeech( frames, CorrelationWinLen.Par, CorrelationShift.Par ) ;
    if( CtrlOutput.Par ) {
      fprintf( stderr, "Correlations\n" ) ;
      PrintCorrelationArray(stderr,frames) ;
      PrintPZMCorrelationArray(stderr,frames) ;
    } ;
  } ;

  // use correlation to pzm signals to detect and reject breath noises???
  if( CorrelationToPZMMin.Par != 0.0 )
    if( UseCorrelPerSpurt.Par )
      UseCorrelationsWithPZM( CorrelationToPZMMin.Par, BreathMinLen.Par, BreathMaxLen.Par, BreathMinDist.Par, BreathMaxDist.Par, NrConsecutiveBreath.Par ) ;
    else if( UseCorrelPerFrame.Par )
      UseCorrelationsWithPZMPerFrame( CorrelationToPZMMin.Par, CorrelationSmoothLen.Par ) ;
 
  sprintf( tmpfilename, "%s-AfterPZMCorrel.trs", argv[outfileindex] ) ;
  tmpfp = fopen( tmpfilename, "w" ) ;
  PrintIntermediateHeader( OutputMode, tmpfp ) ;
  PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
  PrintIntermediateFooter( OutputMode, tmpfp ) ;
  fclose(tmpfp) ;
 
  // use correlations between channels te reject overlap regions? (only when threshold below 1.0)
  if( UseCorrelPerSpurt.Par && CorrelationThres.Par < 1.0 )
    UseCorrelationsMultiPass( CorrelationThres.Par, CorrelThresMinLen.Par, CorrelationMaxOverlap.Par, CorrelationMinThres.Par, CorrelationStepSize.Par ) ;  // ->SpeechFlagOut
  else if( UseCorrelPerFrame.Par && CorrelationThres.Par < 1.0 )
    UseCorrelationsPerFrame( CorrelationThres.Par, CorrelationSmoothLen.Par ) ; // ->SpeechFlagOut


  sprintf( tmpfilename, "%s-AfterCorrelAndPZMCorrel.trs", argv[outfileindex] ) ;
  tmpfp = fopen( tmpfilename, "w" ) ;
  PrintIntermediateHeader( OutputMode, tmpfp ) ;
  PrintIntermediateResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, tmpfp ) ;
  PrintIntermediateFooter( OutputMode, tmpfp ) ;
  fclose(tmpfp) ;
  
  PrintResults( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par, ResultRealId.Par, ResultIndivOut.Par ) ; // SpeechFlag[][]->XML 
  //PrintResultsWithPZMCorrel( OverlapWanted.Par, OutputMode, SpeechLabel.Par, NonspeechLabel.Par, SpeechOffset.Par ) ; // SpeechFlag[][]->XML 

  PrintFooter( OutputMode, ResultRealId.Par, ResultIndivOut.Par ) ;


#ifdef TESTLEVEL
  fprintf( stderr, "Free memory ...\n" ) ;
#endif

    
  for( i=0 ; i<nrchanwav ; i++ ) {
    fclose( outfp[i] ) ;    
    if( AkuPre[i] != 0 ) {
      AkuPre[i]->clearAkuPre();
      delete AkuPre[i] ;
    } ;
  } ;
  delete[] AkuPre ;
 
  if( Channel != 0 )
    delete[] Channel ;
  if( energymin != 0 )
    delete[] energymin ;
  if( prefp != 0 )
    delete[] prefp ;
  
  //AkuPre.appendPar( stderr ) ;
#ifdef TESTLEVEL
  fprintf( stderr, "Done\n") ;
#endif
  return _OK_;
}
