#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "fileconst.h"


int main( int argc, char *argv[] ) {

  if( argc < 5 ) {
    fprintf( stderr, "%s <stmfile> <outfile> <nrchan> <startframe> <endframe>\n", argv[0] ) ;
    exit(-1) ;
  }

  int chan, last_end, nrframe, beg, end, sent;
  int i,j,k, datasize ;
  int startframe, endframe, nrchan ;

  char stmfile[MaxLineLength] ;
  char outfile[MaxLineLength] ;
  char tmp[MaxLineLength] ;
  char line[20*MaxLineLength] ;
  char transcript[20*MaxLineLength] ;
  nrchan = strtol( argv[3], NULL, 10 ) ;
  startframe = strtol( argv[4], NULL, 10 );
  endframe = strtol( argv[5], NULL, 10 );
  char *tmp2 ;
  int count;


  strcpy( stmfile, argv[1] ) ;
  strcpy( outfile, argv[2] ) ;
  FILE *stmfp ;
  FILE *outfp ;

 
  nrframe = endframe - startframe + 1 ;

  datasize = nrframe * 3 ;

  int speech = 1 ;
  int nonspeech = 0 ;


  fprintf( stderr, "start: %d, end: %d, nrframe: %d\n", startframe, endframe, nrframe ) ; 


  for( i=0; i<nrchan; i++ ) {

    stmfp = fopen( stmfile, "r" ) ;
    if( stmfp == 0 ) {
      fprintf( stderr, "Can't open file '%s' for reading\n", stmfile ) ;
      exit(-1) ;
    }
    
    sprintf( tmp, "%s%d.lab", outfile, i ) ;
    outfp = fopen( tmp, "w" ) ;

    if( outfp == 0 ) {
      fprintf( stderr, "Can't open file '%s' for writing\n", tmp ) ;
      exit(-1) ;
    }
    
    fprintf( outfp, "-pfile_header version 0 size 32768\n" ) ;
    fprintf( outfp, "-num_sentences 1\n" ) ;
    fprintf( outfp, "-num_frames %d\n", nrframe ) ;
    fprintf( outfp, "-first_feature_column 2\n" ) ;
    fprintf( outfp, "-num_features %d\n", 0 ) ;
    fprintf( outfp, "-first_label_column %d\n", 2 ) ;
    fprintf( outfp, "-num_labels %d\n", 1 ) ;
    fprintf( outfp, "-format %s\n", "2dd" ) ;
    fprintf( outfp, "-data size %d offset %d ndim %d nrow %d ncol %d\n",  nrframe*(1+2), 0, 2, nrframe, 1+2  ) ;
    fseek( outfp, 32768, 0 ) ;



    last_end = startframe-1 ;
    sent = 0 ;
   
    rewind( stmfp ) ;
    while( fgets( line, 20*MaxLineLength, stmfp ) ) {
      
      strtok( line, " \t" ) ;
      
      chan = strtol( strtok( NULL, " \t" ), NULL, 10 );
      strtok( NULL, " \t" );
      
      beg = (int)(strtod( strtok( NULL, " \t" ), NULL ) *100 + 0.5);
      end = (int)(strtod( strtok( NULL, " \t" ), NULL ) *100 + 0.5);
      
      if( strtok( NULL, " \t" ) == 0 ) {
	fprintf( stderr, "Empty line found: channel %d, beg %d, end %d\n", chan, beg, end ) ;
	exit(-1) ;
      }

      count = 1 ;
      if( (tmp2 = strtok( NULL, " \t\n" )) == 0 ) {
	count=1 ;
      } else {
	while( strtok( NULL, " \t\n" ) != 0 ) {
	  count++ ;
	}
      }

      if( chan == i ) {

	//fprintf( stderr, "chan: %d, beg: %d, end: %d\t", chan,beg,end) ;
	//fprintf( stderr, "%s\n", tmp2 ) ;

	for( j=last_end ; j<beg ; j++ ) {
	  if( j>=startframe && j<=endframe ) {
	    k=j-startframe ;
	    fwrite( &sent,  sizeof(int), 1, outfp ) ;
	    fwrite( &k, sizeof(int), 1, outfp ) ;
	    fwrite( &nonspeech, sizeof(int), 1, outfp ) ; 
	    //fprintf( stderr, "j: %d, k: %d\n", j,k) ;

	  }
	}
	
	for( j=beg ; j<end ; j++ ) {
	  if( j>=startframe && j<=endframe ) {
	    k=j-startframe ;
	    fwrite( &sent,  sizeof(int), 1, outfp ) ;
	    fwrite( &k, sizeof(int), 1, outfp ) ;
	    if( count==1 ) {
	      if( strcmp( tmp2, "[noise]") == 0 || strcmp( tmp2, "[mouth]") == 0 || strcmp( tmp2, "()") == 0) 
		fwrite( &nonspeech, sizeof(int), 1, outfp ) ; 
	      else 
		fwrite( &speech, sizeof(int), 1, outfp ) ; 
	    } else 
	      fwrite( &speech, sizeof(int), 1, outfp ) ; 
	    //fprintf( stderr, "j: %d, k: %d\n", j,k) ;
	  }
	}
	last_end = end ;
      }
    }
         
    for( j=last_end ; j<=endframe ; j++ ) {
      if( j>=startframe && j<=endframe ) {
	k=j-startframe ;
	fwrite( &sent,  sizeof(int), 1, outfp ) ;
	fwrite( &k, sizeof(int), 1, outfp ) ;
	fwrite( &nonspeech, sizeof(int), 1, outfp ) ; 
	//fprintf( stderr, "j: %d, k: %d, last_end: %d, startframe :%d, endframe: %d\n", j,k,last_end, startframe, endframe) ;
      }
    }

    fclose( outfp ) ;
    fclose(stmfp);

  }
  
  
  delete[] outfp ;
  
}
